SystemOrganization addCategory: #Prolog!
SystemOrganization addCategory: #'Prolog-Test'!

StringHolder subclass: #PrologInterpreter
	instanceVariableNames: 'systemPredicates userPredicates status definition question questionEnv clause clauseEnv queue queueEnv envCounter valueEnv unbindList cutBack backTrack resolveAction definitionStack tracePredicates traceCounter textValue textCollector verbose listValue predicate'
	classVariableNames: 'SystemPredicates'
	poolDictionaries: ''
	category: 'Prolog'!

!PrologInterpreter commentStamp: 'nsh 8/31/2008 08:01' prior: 0!
Prolog
Goodies for Squeak 3.0

This goodies is a modification for Squeak from Mr. AOKI's
Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/Prolog.st
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/Prolog.txt
!

!PrologInterpreter class methodsFor: 'copyright' stamp: ''!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!PrologInterpreter class methodsFor: 'examples' stamp: ''!
example
	"PrologInterpreter example."

	PrologInterpreter open! !

!PrologInterpreter class methodsFor: 'examples' stamp: ''!
example01
	"PrologInterpreter example01."

	| string prolog result |
	string := '

	?- remove.	   % remove all predicates in PrologDataBase.
	likes(john,mary).    % assert fact.
	likes(john,wine).    % assert fact.
	likes(mary,wine).    % assert fact.
	likes(mary,john).    % assert fact.
	?- likes(X,Y).		   % question goal.
	?- likes(john,X), likes(mary,X). % question goal.

	'.
	prolog := PrologInterpreter new.
	prolog textCollector: Transcript.
	result := prolog refute: string
				action: 
					[:answer | 
					answer keys asSortedCollection
						do: 
							[:s | 
							Transcript show: s.
							Transcript show: ' = '.
							Transcript show: (answer at: s) printPrologString.
							Transcript cr].
					prolog confirm: 'All right?'].
	Transcript show: result printString; cr! !

!PrologInterpreter class methodsFor: 'examples' stamp: ''!
example02
	"PrologInterpreter example02."

	| string prolog result |
	string := '

	?- remove.	   % remove all predicates in PrologDataBase.
	on(hen,cat).
	on(cat,dog).
	on(dog,donkey).
	above(X,Y) :-
	    on(X,Y).
	above(X,Y) :-
	    on(X,Z), above(Z,Y).
	?- on(X,dog).
	?- above(X,dog).

	'.
	prolog := PrologInterpreter new.
	prolog textCollector: Transcript.
	result := prolog refute: string
				action: 
					[:answer | 
					answer keys asSortedCollection
						do: 
							[:s | 
							Transcript show: s.
							Transcript show: ' = '.
							Transcript show: (answer at: s) printPrologString.
							Transcript cr].
					prolog confirm: 'All right?'].
	Transcript show: result printString; cr! !

!PrologInterpreter class methodsFor: 'examples' stamp: ''!
example03
	"PrologInterpreter example03."

	| string prolog result |
	string := '

	?- remove.	% remove all predicates in PrologDataBase.
	hanoi(N) :-	% This is Hanoi Tower Prolgram.
	    move(N,left,right,center).
	    move(0,X,Y,Z) :- !!.
	move(N,A,B,C) :-
	    -(N,1,M),
	    move(M,A,C,B),
	    inform(A,B),
	    move(M,C,B,A).
	inform(X,Y) :-
	    write([move,disc,from,X,to,Y]),
	    nl.
	?- hanoi(3).	 % question goal.

	'.
	prolog := PrologInterpreter new.
	prolog textCollector: Transcript.
	result := prolog refute: string
				action: 
					[:answer | 
					answer keys asSortedCollection
						do: 
							[:s | 
							Transcript show: s.
							Transcript show: ' = '.
							Transcript show: (answer at: s) printPrologString.
							Transcript cr].
					prolog confirm: 'All right?'].
	Transcript show: result printString; cr! !

!PrologInterpreter class methodsFor: 'examples' stamp: ''!
example04
	"PrologInterpreter example04."

	| string prolog result |
	string := '?- append(X,Y,[a,b,c,d]).'.
	prolog := PrologInterpreter new.
	prolog textCollector: Transcript.
	result := prolog refute: string
				action: 
					[:answer | 
					answer keys asSortedCollection
						do: 
							[:s | 
							Transcript show: s.
							Transcript show: ' = '.
							Transcript show: (answer at: s) printPrologString.
							Transcript cr].
					prolog confirm: 'All right?'].
	Transcript show: result printString; cr! !

!PrologInterpreter class methodsFor: 'examples' stamp: 'nishis 4/21/98 02:31'!
example05
	"PrologInterpreter example05."

	| string prolog result |
	string := '

	image({Form fromUser}).
	graphicsContext({Display}).
	point({100@100}).
	?- image(X), graphicsContext(Y), point(Z), send(X,displayOn:at:,[Y,Z]).

	'.
	prolog := PrologInterpreter new.
	prolog textCollector: Transcript.
	result := prolog refute: string
				action: 
					[:answer | 
					answer keys asSortedCollection
						do: 
							[:s | 
							Transcript show: s.
							Transcript show: ' = '.
							Transcript show: (answer at: s) printPrologString.
							Transcript cr].
					prolog confirm: 'All right?'].
	Transcript show: result printString; cr! !

!PrologInterpreter class methodsFor: 'examples' stamp: ''!
example06
	"PrologInterpreter example06."

	| string prolog result |
	string := '

	?- send(123,+,[456],X).   % X := 123 + 456.

	'.
	prolog := PrologInterpreter new.
	prolog textCollector: Transcript.
	result := prolog refute: string
				action: 
					[:answer | 
					answer keys asSortedCollection
						do: 
							[:s | 
							Transcript show: s.
							Transcript show: ' = '.
							Transcript show: (answer at: s) printPrologString.
							Transcript cr].
					prolog confirm: 'All right?'].
	Transcript show: result printString; cr! !

!PrologInterpreter class methodsFor: 'examples' stamp: ''!
example07
	"PrologInterpreter example07."

	| string prolog result |
	string := '

	?- is(X,+(3,4)).
	?- is(X,F(3,4)).

	'.
	prolog := PrologInterpreter new.
	prolog textCollector: Transcript.
	result := prolog refute: string
				action: 
					[:answer | 
					answer keys asSortedCollection
						do: 
							[:s | 
							Transcript show: s.
							Transcript show: ' = '.
							Transcript show: (answer at: s) printPrologString.
							Transcript cr].
					prolog confirm: 'All right?'].
	Transcript show: result printString; cr! !

!PrologInterpreter class methodsFor: 'examples' stamp: 'nishis 5/3/98 13:39'!
example08
	"PrologInterpreter example08."

	| anInterpreter aBlock aString |
	anInterpreter := PrologInterpreter new.
	anInterpreter contents: '?- append(X,Y,[1,2,3,4]).'.
	aBlock :=
		['?- append(X,Y,[1,2,3,4]).
X = [] ,
Y = [1,2,3,4] ;
X = [1] ,
Y = [2,3,4] ;
X = [1,2] ,
Y = [3,4] ;
X = [1,2,3] ,
Y = [4] ;
X = [1,2,3,4] ,
Y = [] ;
no'
			do:
				[:aCharacter |
				Processor yield.
				aString := String with: aCharacter.
				anInterpreter textCollector show: aString]].
	aBlock fixTemps; fork.
	anInterpreter open! !

!PrologInterpreter class methodsFor: 'class initialization' stamp: ''!
flushOthers
	"PrologInterpreter flushOthers."

	self flushSystemPredicates! !

!PrologInterpreter class methodsFor: 'class initialization' stamp: ''!
flushSystemPredicates
	"PrologInterpreter flushSystemPredicates."

	SystemPredicates := nil! !

!PrologInterpreter class methodsFor: 'class initialization' stamp: 'nishis 4/21/98 02:32'!
initialize
	"PrologInterpreter initialize."

	self installMessagesForProlog! !

!PrologInterpreter class methodsFor: 'class initialization' stamp: 'nsh 2/21/2009 20:12'!
installMessagesForProlog
	"PrologInterpreter installMessagesForProlog."

	| source stream |
	source := '
!!Object methodsFor: ''' , self protocol, '''!!

car
	self == nil ifTrue: [^nil].
	self error: ''send message car to atom''!!

cdr
	self == nil ifTrue: [^nil].
	self error: ''send message cdr to atom''!!

cons: anObject 
	^PrologList car: self cdr: anObject!!

consp
	^false!!

isPrologEntity
	self == nil ifTrue: [^true].
	(self isKindOf: Number)
		ifTrue: [^true].
	^false!!

isPrologVariable
	^false!!

printPrologOn: aStream 
	self == nil
		ifTrue: 
			[aStream nextPutAll: ''[]''.
			^self].
	(self isKindOf: Number)
		ifTrue: 
			[self printOn: aStream.
			^self].
	aStream nextPut: ${.
	self printOn: aStream.
	aStream nextPut: $}!!

printPrologOn: aStream level: anInteger 
	self printPrologOn: aStream!!

printPrologString
	| aStream |
	aStream := WriteStream on: (String new: 20).
	self printPrologOn: aStream.
	^aStream contents!! !!
'.
	stream := ReadWriteStream
				on: source
				from: 0
				to: source size.
	stream fileIn! !

!PrologInterpreter class methodsFor: 'private' stamp: 'nsh 9/8/2008 00:24'!
modalFileSelectorWithCaption: caption 
	"PrologInterpreter modalFileSelectorWithCaption: 'aaa'."
	| window labelMorphs |
	window := FileList2 morphicViewFileSelector.
	labelMorphs := OrderedCollection new.
	(window submorphs
		select: [:each | each isKindOf: AlignmentMorph])
		do: [:anAlignmentMorph | labelMorphs
				addAll: (anAlignmentMorph allMorphs
						select: [:each | (each isKindOf: StringMorph)
								and: [(each allOwners
										select: [:anOwner | anOwner isKindOf: PluggableButtonMorph]) isEmpty]])].
	labelMorphs isEmpty not
		ifTrue: [labelMorphs first contents: caption].
	window openCenteredInWorld.
	[window world notNil]
		whileTrue: [window outermostWorldMorph doOneCycle].
	^ (window valueOfProperty: #fileListModel) getSelectedFile! !

!PrologInterpreter class methodsFor: 'instance creation' stamp: ''!
new
	^super new initialize! !

!PrologInterpreter class methodsFor: 'class initialization' stamp: ''!
obsolete
	self uninstallMessagesForProlog.
	super obsolete! !

!PrologInterpreter class methodsFor: 'instance creation' stamp: 'nishis 4/21/98 03:02'!
open
	"PrologInterpreter open."

	self openOn: self new! !

!PrologInterpreter class methodsFor: 'instance creation' stamp: 'nishis 4/21/98 03:00'!
openOn: prologInterpreter
	"PrologInterpreter open."

	prologInterpreter open! !

!PrologInterpreter class methodsFor: 'private' stamp: 'nsh 2/21/2009 20:09'!
protocol
	^ #'*Goodies-Prolog-*prolog'! !

!PrologInterpreter class methodsFor: 'public access' stamp: ''!
refute: stringOrStream 
	^self new refute: stringOrStream! !

!PrologInterpreter class methodsFor: 'public access' stamp: ''!
refute: stringOrStream action: aBlock 
	^self new refute: stringOrStream action: aBlock! !

!PrologInterpreter class methodsFor: 'saving' stamp: 'nsh 9/8/2008 06:45'!
save
	"PrologInterpreter save."
	| fileName classCollection aStream timeStamp |
	fileName := 'Prolog.st'.
	classCollection := self saveClasses.
	aStream := FileStream newFileNamed: fileName asFileName.
	[aStream reset.
	Cursor write
		showWhile: [timeStamp := Date today mmddyyyy , ' ' , Time now asString.
			aStream cr.
			aStream nextChunkPut: timeStamp printString.
			aStream cr; cr.
			(self comment isNil
					or: [self comment isEmpty])
				ifFalse: [aStream nextChunkPut: self comment asString printString.
					aStream cr; cr].
			classCollection
				do: [:aClass | 
					aStream nextChunkPut: aClass definition.
					aStream cr; cr].
			classCollection
				do: [:aClass | 
					aStream nextPut: Character newPage.
					aStream cr.
					aClass fileOutOn: aStream.
					aStream cr]]]
		ensure: [aStream close].
	^ classCollection! !

!PrologInterpreter class methodsFor: 'saving' stamp: 'nsh 9/8/2008 10:02'!
saveClasses
	"PrologInterpreter saveClasses."
	| patternCollection classCollection string something |
	patternCollection := #('Prolog*' ).
	classCollection := SystemOrganization superclassOrder: self category.
	classCollection addAll: (SystemOrganization superclassOrder: 'Goodies-Prolog-Test').
	classCollection := ChangeSet superclassOrder: classCollection.
	classCollection := classCollection
				select: [:aClass | 
					string := aClass name asString.
					something := patternCollection
								detect: [:it | it match: string]
								ifNone: [].
					something notNil].
	^ classCollection! !

!PrologInterpreter class methodsFor: 'copyright' stamp: ''!
system
	^'Goodies'! !

!PrologInterpreter class methodsFor: 'class initialization' stamp: 'nsh 2/21/2009 20:09'!
uninstallMessagesForProlog
	"PrologInterpreter uninstallMessagesForProlog."

	| target protocol organizer selectors |
	target := Object.
	protocol := self protocol.
	organizer := target organization.
	selectors := organizer listAtCategoryNamed: protocol.
	selectors do: [:selector | target removeSelector: selector].
	organizer removeCategory: protocol! !

!PrologInterpreter class methodsFor: 'copyright' stamp: ''!
version
	^'003'! !

!PrologInterpreter methodsFor: 'adaptor' stamp: ''!
acceptConsulting: aText 
	| readStream |
	textCollector show: '<consult from user>\' withCRs.
	readStream := ReadStream on: aText asString.
	self consult: readStream action: nil.
	^true! !

!PrologInterpreter methodsFor: 'adaptor' stamp: ''!
acceptEditing: aText 
	| readStream |
	textCollector show: '<reconsult from editor>\' withCRs.
	readStream := ReadStream on: aText asString.
	Cursor read showWhile: [self reconsult: readStream action: nil].
	self updatePredList.
	^true! !

!PrologInterpreter methodsFor: 'adaptor' stamp: ''!
acceptQuestion: aText 
	^true! !

!PrologInterpreter methodsFor: 'adaptor' stamp: ''!
acceptReconsulting: aText 
	| readStream |
	textCollector show: '<reconsult from user>\' withCRs.
	readStream := ReadStream on: aText asString.
	Cursor read showWhile: [self reconsult: readStream action: nil].
	^true! !

!PrologInterpreter methodsFor: 'private' stamp: 'nsh 8/30/2008 19:50'!
acceptWith: aText
	"force to regist aText as a contents."

	self contents: aText.
	textValue := aText.
	self changed: #clearUserEdits.
	^ true! !

!PrologInterpreter methodsFor: 'system predicates' stamp: ''!
asserta: aPrologClause 
	| horn def functor |
	horn := aPrologClause.
	horn consp ifFalse: [horn := PrologStructure functor: horn terms: nil].
	horn car consp ifFalse: [horn := PrologClause head: horn body: nil].
	horn := PrologClause head: horn car body: (PrologBody fromList: horn cdr).
	functor := horn car car.
	def := userPredicates at: functor ifAbsent: [nil].
	def == nil
		ifTrue: 
			[def := PrologDefinition fromList: (horn cons: nil).
			userPredicates at: functor put: def]
		ifFalse: 
			[def := PrologDefinition fromList: (horn cons: def).
			userPredicates at: functor put: def].
	^true! !

!PrologInterpreter methodsFor: 'system predicates' stamp: ''!
assertz: aPrologClause 
	| horn def functor |
	horn := aPrologClause.
	horn consp ifFalse: [horn := PrologStructure functor: horn terms: nil].
	horn car consp ifFalse: [horn := PrologClause head: horn body: nil].
	horn := PrologClause head: horn car body: (PrologBody fromList: horn cdr).
	functor := horn car car.
	def := userPredicates at: functor ifAbsent: [nil].
	def == nil
		ifTrue: 
			[def := PrologDefinition fromList: (horn cons: nil).
			userPredicates at: functor put: def]
		ifFalse: [def nconc: (PrologDefinition fromList: (horn cons: nil))].
	^true! !

!PrologInterpreter methodsFor: 'private' stamp: 'nishis 5/3/98 08:05'!
associations: aCollection
	"by nishis, 1998/04/12 07:34"

	| anOrderedCollection |
	anOrderedCollection := OrderedCollection new: aCollection size.
	aCollection associationsDo: [:association | anOrderedCollection add: association].
	^ anOrderedCollection! !

!PrologInterpreter methodsFor: 'resolve modules' stamp: ''!
back
	| array |
	backTrack == nil
		ifTrue: 
			[status := #fail.
			^self].
	array := backTrack car.
	backTrack := backTrack cdr.
	clause := array at: 1.
	clauseEnv := array at: 2.
	queue := array at: 3.
	queueEnv := array at: 4.
	cutBack := array at: 5.
	definition := array at: 6.
	array := array at: 7.
	self unbindFrom: unbindList to: array.
	unbindList := array.
	status := #next! !

!PrologInterpreter methodsFor: 'binding and unbinding' stamp: ''!
bind: x env: xEnv and: y env: yEnv 
	| list |
	list := (self fetchValue: y env: yEnv) cons: valueEnv.
	list := (x cons: list) cons: xEnv cdr. 
	xEnv cdr: list. 
	unbindList := xEnv cons: unbindList! !

!PrologInterpreter methodsFor: 'binding and unbinding' stamp: ''!
binding: x env: xEnv 
	| assocList |
	assocList := xEnv cdr.
	assocList == nil ifTrue: [^nil].
	^assocList assoc: x! !

!PrologInterpreter methodsFor: 'kernel predicates' stamp: ''!
builtInCut
	backTrack := cutBack car.
	clause := clause cdr.
	status := #loop! !

!PrologInterpreter methodsFor: 'kernel predicates' stamp: ''!
builtInFail
	status := #back! !

!PrologInterpreter methodsFor: 'kernel predicates' stamp: ''!
builtInPredicate: functor 
	functor isPrologCut ifTrue: [^self builtInCut].
	functor isPrologTrue ifTrue: [^self builtInTrue].
	functor isPrologFail ifTrue: [^self builtInFail].
	functor isPrologSend ifTrue: [^self builtInSend].
	functor isPrologVar ifTrue: [^self builtInVar].
	self error: 'Unexpected built-in predicate'! !

!PrologInterpreter methodsFor: 'kernel predicates' stamp: ''!
builtInSend
	| list receiverSymbol selectorSymbol argumentList unifyTerm result |
	list := self expression: clause car cdr env: clauseEnv.
	receiverSymbol := list car.
	list := list cdr.
	selectorSymbol := list car.
	list := list cdr.
	argumentList := list car.
	list := list cdr.
	list == nil
		ifTrue: [unifyTerm := nil]
		ifFalse: [list cdr == nil
				ifTrue: [unifyTerm := clause car cdr nth: 4]
				ifFalse: 
					[status := #back.
					^self]].
	result := self
				receiver: receiverSymbol
				selector: selectorSymbol
				arguments: argumentList.
	result = PrologSymbol cut
		ifTrue: 
			[self builtInCut.
			status := #back.
			^self].
	unifyTerm isNil
		ifTrue: 
			[result = false ifFalse: [result := true].
			result
				ifTrue: 
					[clause := clause cdr.
					status := #loop.
					^self]
				ifFalse: 
					[status := #back.
					^self]]
		ifFalse: [(self
				unify: unifyTerm
				env: clauseEnv
				and: result
				env: self nullEnv)
				ifTrue: 
					[clause := clause cdr.
					status := #loop.
					^self]
				ifFalse: 
					[status := #back.
					^self]].
	^self! !

!PrologInterpreter methodsFor: 'kernel predicates' stamp: ''!
builtInTrue
	clause := clause cdr.
	status := #loop! !

!PrologInterpreter methodsFor: 'kernel predicates' stamp: ''!
builtInVar
	| var |
	var := clause car cdr car.
	(self noValue: var env: clauseEnv)
		ifTrue: 
			[clause := clause cdr.
			status := #loop]
		ifFalse: [status := #back]! !

!PrologInterpreter methodsFor: 'kernel predicates' stamp: ''!
call: aPrologStructure 
	| structure functor |
	aPrologStructure cdr == nil
		ifTrue: 
			[self callVariable: aPrologStructure car.
			^self].
	structure := self expression: aPrologStructure env: clauseEnv.
	(self
		unify: aPrologStructure
		env: clauseEnv
		and: structure
		env: clauseEnv)
		ifFalse: [self error: 'Unexpected unify structure'].
	functor := structure car.
	functor isPrologVariable
		ifTrue: 
			[status := #back.
			^self].
	clause := clause cdr.
	clause := structure cons: clause.
	status := #loop! !

!PrologInterpreter methodsFor: 'kernel predicates' stamp: ''!
callVariable: aPrologVariable 
	| horn functor |
	horn := self expression: aPrologVariable env: clauseEnv.
	(self
		unify: aPrologVariable
		env: clauseEnv
		and: horn
		env: clauseEnv)
		ifFalse: [self error: 'Unexpected unify horn clause'].
	horn consp ifFalse: [horn := PrologStructure functor: horn terms: nil].
	horn car consp ifFalse: [horn := PrologClause head: horn body: nil].
	horn := PrologClause head: horn car body: (PrologBody fromList: horn cdr).
	functor := horn car car.
	functor isPrologVariable
		ifTrue: 
			[status := #back.
			^self].
	clause := clause cdr.
	horn := horn reverse.
	[horn consp]
		whileTrue: 
			[clause := horn car cons: clause.
			horn := horn cdr].
	status := #loop! !

!PrologInterpreter methodsFor: 'system predicates' stamp: ''!
clause: aPrologClause 
	| count horn def result |
	count := 0.
	horn := aPrologClause.
	horn consp
		ifFalse: 
			[horn := PrologStructure functor: horn terms: nil.
			count := count + 1].
	horn car consp
		ifFalse: 
			[horn := PrologClause head: horn body: nil.
			count := count + 1].
	horn := PrologClause head: horn car body: (PrologBody fromList: horn cdr).
	def := definitionStack car.
	[def consp]
		whileTrue: [(self
				unify: horn
				env: self nullEnv
				and: def car
				env: self nullEnv)
				ifTrue: 
					[result := def car.
					count timesRepeat: [result := result car].
					def := def cdr.
					definitionStack car: def.
					^result]
				ifFalse: 
					[def := def cdr.
					definitionStack car: def]].
	definitionStack := definitionStack cdr.
	^PrologSymbol cut! !

!PrologInterpreter methodsFor: 'system support' stamp: ''!
clauseSet: aPrologClause 
	| horn functor def |
	horn := aPrologClause.
	horn consp ifFalse: [horn := PrologStructure functor: horn terms: nil].
	horn car consp ifFalse: [horn := PrologClause head: horn body: nil].
	horn := PrologClause head: horn car body: (PrologBody fromList: horn cdr).
	functor := horn car car.
	def := userPredicates at: functor ifAbsent: [^false].
	definitionStack := def cons: definitionStack.
	^true! !

!PrologInterpreter methodsFor: 'system predicates' stamp: ''!
clear
	textCollector clear.
	^true! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nsh 9/7/2008 23:24'!
codePaneMenu: aMenu shifted: shifted 
	| receiver subMenu selection controller menuLabel |
	receiver := thisContext sender receiver.
	Smalltalk isMorphic
		ifTrue: [subMenu := MenuMorph new.
			(receiver respondsTo: #textMorph)
				ifTrue: [selection := receiver textMorph selection.
					controller := receiver]
				ifFalse: [selection := (controller := (receiver instVarNamed: #textMorph) editor) selection].
menuLabel _ 'prolog']
		ifFalse: [subMenu := CustomMenu new.
			controller := receiver controller.
			selection := controller selection.
			menuLabel _ 'prolog...'].
	aMenu
		add: menuLabel
		subMenu: (self
				prologMenuOn: subMenu
				receiver: receiver
				controller: controller
				selection: selection)
		target: nil
		selector: nil
		argumentList: #(nil ).
	aMenu addLine.
	super codePaneMenu: aMenu shifted: shifted.
	^ aMenu! !

!PrologInterpreter methodsFor: 'representation' stamp: ''!
collectVariables
	| dict | 
	dict := Dictionary new.
	self collectVariables: question to: dict.
	^dict! !

!PrologInterpreter methodsFor: 'representation' stamp: ''!
collectVariables: x to: dict
	| key value |  
	(x isPrologVariable and: [(x at: 1) ~= $~])
		ifTrue:
			[key := String fromString: x printPrologString.
			(dict at: key ifAbsent: []) ~~ nil
				ifTrue: [^self]
				ifFalse: 
					[value := self represent: x env: questionEnv.
					dict at: key put: value]].
	(x consp)
		ifFalse: [^self].
	self collectVariables: x car to: dict.
	self collectVariables: x cdr to: dict! !

!PrologInterpreter methodsFor: 'public accessing' stamp: ''!
confirm: messageString 
	^super confirm: messageString! !

!PrologInterpreter methodsFor: 'system predicates' stamp: 'nishis 4/27/98 05:21'!
consult
	| aModel |
	aModel := self copy.
	aModel perform: #consultingInterface.
	^true! !

!PrologInterpreter methodsFor: 'system support' stamp: 'nsh 8/31/2008 07:30'!
consult: readStream action: aBlock
	| condition parser node hornClause program functor stream result |
	condition := self getCondition.
	parser := PrologParser new.
	result := true.
	[node := parser parse: readStream.
	node == #eof]
		whileFalse: 
			[hornClause := node cdr.
			node car
				ifTrue: 
					[stream := WriteStream on: (String new: 20).
					hornClause questionPrintPrologOn: stream.
					textCollector show: stream contents.
					textCollector cr.
					result := self resolve: hornClause action: aBlock]
				ifFalse: 
					[functor := hornClause car car.
					program := tracePredicates at: functor ifAbsent: [userPredicates at: functor ifAbsent: []].
					program == nil
						ifTrue: 
							[program := PrologDefinition fromList: (hornClause cons: nil).
							userPredicates at: functor put: program]
						ifFalse: [program nconc: (hornClause cons: nil)]]].
	self putCondition: condition.
	^result! !

!PrologInterpreter methodsFor: 'system predicates' stamp: 'nsh 9/8/2008 02:58'!
consultFile: fileName 
	| aFileStream |
	(fileName respondsTo: #asString)
		ifFalse: [^ false].
	(FileDirectory default fileExists: fileName)
		ifTrue: [textCollector show: '<consult from ' , fileName asString , '>\' withCRs.
			aFileStream := FileStream oldFileNamed: fileName.
			[self consult: aFileStream action: nil]
				ensure: [aFileStream close].
			^ true]
		ifFalse: [^ false]! !

!PrologInterpreter methodsFor: 'menu messages' stamp: 'nsh 9/8/2008 02:33'!
consulting
	| prompt aFileName |
	prompt := 'Please type a name for consulting file.' translated.
	aFileName := Smalltalk isMorphic
				ifTrue: [| aFileStream | (aFileStream := self modalFileSelectorWithCaption: prompt) notNil
						ifTrue: [aFileStream name]]
				ifFalse: [| selection | (selection := PrologPluggableFileList newFilePrompt: prompt) notNil
						ifTrue: [selection directory fullNameFor: selection name]].
	(aFileName isNil
			or: [aFileName asString isEmpty
					or: [aFileName asString = 'user']])
		ifTrue: [^ self consult]
		ifFalse: [^ self consultFile: aFileName asString]! !

!PrologInterpreter methodsFor: 'interface opening' stamp: 'nsh 9/8/2008 05:58'!
consultingInterface
	| copySelf topView textView |
	Smalltalk isMorphic ifTrue: [^ self consultingInterfaceAsMorph].
	copySelf := self copy.
	topView := StandardSystemView new
			model: copySelf;
			backgroundColor: Color white;
			label: 'Prolog Consultant';
			minimumSize: 250 @ 200.
"	textView := PluggableStringHolderView
			on: copySelf
			aspect: #consultingTextValue 
			change: #consultingTextValueChange: 
			menu: #consultingTextMenu."
	textView := PluggableTextView on: copySelf 
			text: #consultingTextValue accept: #consultingTextValueChange:
			readSelection: #contentsSelection menu: #consultingMenu:shifted:.
	textView
			window: (0 @ 0 extent: 250 @ 200);
			borderWidth: 2; 
			backgroundColor: Color lightYellow.
	topView addSubView: textView.
	topView  controller open! !

!PrologInterpreter methodsFor: 'interface opening' stamp: 'nsh 9/8/2008 06:02'!
consultingInterfaceAsMorph
	| copySelf topView textView |
	copySelf := self copy.
	topView := (SystemWindow labelled: 'Prolog Consultant') model: copySelf.
	topView setStripeColorsFrom: self defaultBackgroundColor.
	topView minimumExtent: 250 @ 200.
	textView := PluggableTextMorph on: copySelf 
			text: #consultingTextValue accept: #consultingTextValueChange:
			"text: #listingText accept: #listingTextValue"
			readSelection: nil menu: #consultingTextMenu:shifted: .
	textView acceptOnCR: true.
	topView 
		addMorph: textView
		frame: (0 @ 0 corner: 1 @ 1).
	[ topView visible: false.
	topView openInWorld.
	topView extent: 250 @ 200 ] ensure: [ topView visible: true ].
	^ topView! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nsh 9/8/2008 06:01'!
consultingMenu: aMenu shifted: shifted 
	^ Smalltalk isMorphic
		ifTrue: [self editingMenu: aMenu shifted: shifted ]
		ifFalse: [super codePaneMenu: aMenu shifted: shifted.]! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nsh 9/8/2008 06:02'!
consultingTextMenu: aMenu shifted: shifted 
	^ self consultingMenu: aMenu shifted: shifted ! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nishis 5/3/98 06:54'!
consultingTextValue
	textValue isNil ifTrue: [textValue := Text new].
	^textValue! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nishis 5/3/98 10:56'!
consultingTextValueChange: aText 
	self acceptConsulting: aText! !

!PrologInterpreter methodsFor: 'private' stamp: ''!
deallocateEnv: env
	| assocList assoc nextEnv |  
	assocList := env cdr.
	[assocList consp]
		whileTrue: 
			[assoc := assocList car.
			nextEnv := assoc cdr cdr.
			assoc cdr cdr: nil.
			nextEnv consp ifTrue: [self deallocateEnv: nextEnv].
			assocList := assocList cdr]! !

!PrologInterpreter methodsFor: 'user interface' stamp: 'nsh 8/31/2008 08:16'!
defaultBackgroundColor
	"Answer the color to be used as the base window color for a window
	whose model is an object of the receiver's class"
	^ Color lightGray! !

!PrologInterpreter methodsFor: 'menu messages' stamp: 'nsh 9/7/2008 22:09'!
doIt: aText from: aController 
	| stream |
	self acceptWith: aText.
	stream := ReadStream on: aText asString.
	self consult: stream action: nil.
	self pred: 0.
	self changed: #predList! !

!PrologInterpreter methodsFor: 'system predicates' stamp: ''!
dotp: x 
	^x consp! !

!PrologInterpreter methodsFor: 'system predicates' stamp: ''!
double: x
	^x isKindOf: Float! !

!PrologInterpreter methodsFor: 'system predicates' stamp: 'nishis 4/27/98 05:21'!
editing
	| aModel |
	aModel := self copy.
	aModel perform: #editingInterface.
	^true! !

!PrologInterpreter methodsFor: 'interface opening' stamp: 'nsh 9/8/2008 06:11'!
editingInterface
	| copySelf topView listView textView |
	Smalltalk isMorphic ifTrue: [^ self editingInterfaceAsMorph].
	copySelf := self copy.
	topView := StandardSystemView new
			model: copySelf;
			backgroundColor: Color white;
			label: 'Prolog Editor';
			minimumSize: 250 @ 200.
	listView := PluggableListView
			on: copySelf 
			list: #predList
			selected: #pred
			changeSelected: #pred:
			menu: #editingListMenu:shifted:.
	listView
			window: (0 @ 0 extent: 75 @ 200);
			borderWidth: 2;
			backgroundColor: Color lightYellow.
	textView := PluggableTextView
			on: copySelf
			text: #editingText accept: #editingTextValue
			readSelection: nil menu: #editingTextMenu:shifted:.
	textView
			window: (75 @ 0 extent: 175 @ 200);
			borderWidthLeft: 0 right: 2 top: 2 bottom: 2; 
			backgroundColor: Color lightYellow.
	topView addSubView: listView.
	topView addSubView: textView toRightOf: listView.
	topView  controller open! !

!PrologInterpreter methodsFor: 'interface opening' stamp: 'nsh 9/8/2008 06:11'!
editingInterfaceAsMorph
	| copySelf topView listView textView |
	copySelf := self copy.
	topView := (SystemWindow labelled: 'Prolog Editor') model: copySelf.
	topView setStripeColorsFrom: self defaultBackgroundColor.
	topView minimumExtent: 250 @ 200.
	listView := PluggableListMorph on: copySelf
			list: #predList
			selected: #pred
			changeSelected: #pred:
			menu: #editingListMenu:shifted:.
	topView 
		addMorph: listView
		frame: (0 @ 0 corner: 0.3 @ 1).
	textView := PluggableTextMorph on: copySelf 
			text: #editingText accept: #editingTextValueChange:
			readSelection: nil menu: #editingTextMenu:shifted:.
	textView acceptOnCR: false.
	topView 
		addMorph: textView
		frame: (0.3 @ 0 corner: 1 @ 1).
	[ topView visible: false.
	topView openInWorld.
	topView extent: 250 @ 200 ] ensure: [ topView visible: true ].
	^ topView! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nsh 9/8/2008 06:10'!
editingListMenu: aMenu shifted: shifted 
	^ self predEditMenu: aMenu shifted: shifted ! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nsh 9/7/2008 16:18'!
editingListValue
	listValue isNil ifTrue: [listValue := PrologListModel new list: self predList; parent: self; controller: self].
	^listValue! !

!PrologInterpreter methodsFor: 'adaptor' stamp: ''!
editingListValueChange: aController 
	self pred: self editingListValue selection! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nsh 9/8/2008 06:01'!
editingMenu: aMenu shifted: shifted 
	"PrologInterpreter flushMenus."

	^ super codePaneMenu: aMenu shifted: shifted
! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nsh 9/7/2008 16:29'!
editingText
	| stream def |
	predicate == nil ifTrue: [^Text new].
	stream := WriteStream on: (String new: 200).
	def := userPredicates at: predicate ifAbsent: [^Text new].
	[def consp]
		whileTrue: 
			[def car prettyPrintPrologOn: stream.
			stream cr.
			def := def cdr].
	^stream contents asText! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nsh 9/8/2008 06:32'!
editingTextMenu: aMenu shifted: shifted 
	"PrologInterpreter flushMenus."
	^ self editingMenu: aMenu shifted: shifted! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nishis 5/3/98 06:54'!
editingTextValue
	textValue isNil ifTrue: [textValue := Text new].
	^textValue! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nsh 9/7/2008 21:25'!
editingTextValueChange: aText 
	self acceptEditing: aText! !

!PrologInterpreter methodsFor: 'representation' stamp: ''!
expression: x env: xEnv 
	| assoc a d |
	x isPrologVariable
		ifTrue: 
			[assoc := self binding: x env: xEnv.
			assoc == nil ifTrue: [^x].
			assoc := assoc cdr.
			^self expression: assoc car env: assoc cdr].
	(x consp) ifFalse: [^x].
	a := self expression: x car env: xEnv.
	d := self expression: x cdr env: xEnv.
	^x class car: a cdr: d! !

!PrologInterpreter methodsFor: 'binding and unbinding' stamp: ''!
fetchValue: x env: xEnv 
	| xx xxEnv assoc |
	xx := x.
	xxEnv := xEnv.
	[true]
		whileTrue: 
			[valueEnv := xxEnv.
			xx isPrologVariable
				ifTrue: 
					[assoc := self binding: xx env: xxEnv.
					assoc == nil ifTrue: [^xx].
					assoc := assoc cdr.
					xx := assoc car.
					xxEnv := assoc cdr]
				ifFalse: [^xx]]! !

!PrologInterpreter methodsFor: 'menu messages' stamp: 'nsh 9/8/2008 02:18'!
fileEdit
	| prompt aFileStream |
	prompt := 'Please select a name for editting file.' translated.
	aFileStream := Smalltalk isMorphic
				ifTrue: [self modalFileSelectorWithCaption: prompt]
				ifFalse: [| selection | 
					selection := PrologPluggableFileList oldFilePrompt: prompt.
					selection notNil
						ifTrue: [selection directory fileNamed: selection name]].
	aFileStream notNil
		ifTrue: [aFileStream edit].
	^ true! !

!PrologInterpreter methodsFor: 'system predicates' stamp: ''!
float: x
	^x isKindOf: Float! !

!PrologInterpreter methodsFor: 'system predicates' stamp: ''!
fraction: x
	^x isKindOf: Fraction! !

!PrologInterpreter methodsFor: 'system predicates' stamp: ''!
functorArityOf: aPrologStructure 
	aPrologStructure isNil ifTrue: [^nil cons: 0].
	(self number: aPrologStructure)
		ifTrue: [^aPrologStructure cons: 0].
	(aPrologStructure respondsTo: #functor)
		ifFalse: [^nil].
	^aPrologStructure functor cons: aPrologStructure arity! !

!PrologInterpreter methodsFor: 'system predicates' stamp: 'nishis 4/21/98 03:21'!
gc
	Transcript cr; show: 'garbage collecting: ', (Smalltalk garbageCollect) asString, ' bytes are available.'.
	^true! !

!PrologInterpreter methodsFor: 'private' stamp: ''!
getCondition
	| condition |
	condition := Array new: 14.
	condition at: 1 put: status.
	condition at: 2 put: definition.
	condition at: 3 put: question.
	condition at: 4 put: questionEnv.
	condition at: 5 put: clause.
	condition at: 6 put: clauseEnv.
	condition at: 7 put: queue.
	condition at: 8 put: queueEnv.
	condition at: 9 put: valueEnv.
	condition at: 10 put: unbindList.
	condition at: 11 put: cutBack.
	condition at: 12 put: backTrack.
	condition at: 13 put: resolveAction.
	condition at: 14 put: definitionStack.
	^condition! !

!PrologInterpreter methodsFor: 'adaptor' stamp: ''!
ignoreMenu
	^nil! !

!PrologInterpreter methodsFor: 'initialize-release' stamp: 'nishis 4/25/98 06:02'!
initialize
	super initialize.
	systemPredicates := Dictionary new.
	userPredicates := Dictionary new.
	tracePredicates := Dictionary new.
	textCollector := TranscriptStream new.
	verbose := false.
	self makeSystemPredicates! !

!PrologInterpreter methodsFor: 'menu messages' stamp: 'nishis 5/3/98 10:47'!
inspectIt: aText from: aController 
	| result stream |
	self acceptWith: aText.
	"see BrowserView browseFullForClass: PluggableStringHolderController method: #sendMenuMessageToModel:."
	stream := ReadStream on: aText asString.
	self consult: stream
		action: 
			[:dict | 
			result := dict.
			self outputVariables: dict].
	result inspect.
	^result! !

!PrologInterpreter methodsFor: 'system predicates' stamp: ''!
integer: x
	^x isKindOf: Integer! !

!PrologInterpreter methodsFor: 'menu messages' stamp: ''!
investigate
	self inspect! !

!PrologInterpreter methodsFor: 'system predicates' stamp: ''!
length: aPrologDotPair 
	aPrologDotPair consp ifFalse: [^0].
	^aPrologDotPair length! !

!PrologInterpreter methodsFor: 'system predicates' stamp: ''!
list: x 
	x == nil ifTrue: [^true].
	^self dotp: x! !

!PrologInterpreter methodsFor: 'system predicates' stamp: ''!
listPrint: aPrologDotPair 
	| list |
	aPrologDotPair consp ifFalse: [^false].
	list := aPrologDotPair.
	[list consp]
		whileTrue: 
			[textCollector show: list car printPrologString , ' '.
			list := list cdr].
	^true! !

!PrologInterpreter methodsFor: 'system predicates' stamp: 'nishis 4/27/98 05:21'!
listing
	| aModel |
	aModel := self copy.
	aModel perform: #listingInterface.
	^true! !

!PrologInterpreter methodsFor: 'interface opening' stamp: 'nsh 9/8/2008 06:23'!
listingInterface
	| copySelf topView listView textView |
	Smalltalk isMorphic ifTrue: [^ self listingInterfaceAsMorph].
	copySelf := self copy.
	topView := StandardSystemView new
			model: copySelf;
			backgroundColor: Color white;
			label: 'Prolog Lister';
			minimumSize: 250 @ 200.
	listView := PluggableListView on: copySelf
			list: #predList
			selected: #pred
			changeSelected: #pred:
			menu: #listingListMenu:shifted:.
			"keystroke: #contextStackKey:from:."
	listView
			window: (0 @ 0 extent: 75 @ 200);
			borderWidth: 2;
			backgroundColor: Color lightYellow.
	textView := PluggableTextView on: copySelf 
			text: #listingText accept: nil
			"text: #listingText accept: #listingTextValue"
			readSelection: nil menu: #listingTextMenu:shifted:.
	textView
			window: (75 @ 0 extent: 175 @ 200);
			borderWidthLeft: 0 right: 2 top: 2 bottom: 2; 
			backgroundColor: Color lightYellow.
	textView controller: PrologNoController new.
	topView addSubView: listView.
	topView addSubView: textView toRightOf: listView.
	topView  controller open! !

!PrologInterpreter methodsFor: 'interface opening' stamp: 'nsh 9/8/2008 06:12'!
listingInterfaceAsMorph
	| copySelf topView listView textView |
	copySelf := self copy.
	topView := (SystemWindow labelled: 'Prolog Lister') model: copySelf.
	topView setStripeColorsFrom: self defaultBackgroundColor.
	topView minimumExtent: 250 @ 200.
	listView := PluggableListMorph on: copySelf
			list: #predList
			selected: #pred
			changeSelected: #pred:
			menu: #listingListMenu:shifted:.
			"keystroke: #contextStackKey:from:."
	"listView menuTitleSelector: #predListSelectorTitle."
	topView 
		addMorph: listView
		frame: (0 @ 0 corner: 0.3 @ 1).
	textView := PluggableTextMorph on: copySelf 
			text: #listingText accept: nil
			"text: #listingText accept: #listingTextValue"
			readSelection: nil menu: nil.
	textView acceptOnCR: false.
	topView 
		addMorph: textView
		frame: (0.3 @ 0 corner: 1 @ 1).
	[ topView visible: false.
	topView openInWorld.
	topView extent: 250 @ 200 ] ensure: [ topView visible: true ].
	^ topView! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nsh 9/8/2008 06:21'!
listingListMenu: aMenu shifted: shifted 
	^ self predListMenu: aMenu shifted: shifted! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nsh 9/7/2008 14:32'!
listingListValue
	listValue isNil ifTrue: [listValue := PrologListModel new list: self predList].
	^listValue! !

!PrologInterpreter methodsFor: 'adaptor' stamp: ''!
listingListValueChange: aController 
	self pred: self listingListValue selection! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nsh 8/31/2008 06:00'!
listingText
	| stream def |
	predicate == nil ifTrue: [^Text new].
	stream := WriteStream on: (String new: 200).
	def := userPredicates at: predicate ifAbsent: [^Text new].
	[def consp]
		whileTrue: 
			[def car prettyPrintPrologOn: stream.
			stream cr.
			def := def cdr].
	^stream contents asText! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nsh 9/8/2008 06:23'!
listingTextMenu: aMenu shifted: shifted 
	^self ignoreMenu! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nishis 5/3/98 06:53'!
listingTextValue
	textValue isNil ifTrue: [textValue := Text new].
	^textValue! !

!PrologInterpreter methodsFor: 'adaptor' stamp: ''!
listingTextValueChange: aController
	^self! !

!PrologInterpreter methodsFor: 'resolve modules' stamp: ''!
loop
	| structure functor |
	clause == nil
		ifTrue: 
			[queue == nil
				ifTrue: 
					[status := #succ.
					^self].
			clause := queue car.
			clauseEnv := queueEnv car.
			queue := queue cdr.
			queueEnv := queueEnv cdr.
			cutBack := cutBack cdr.
			status := #loop.
			^self].
	structure := clause car.
	structure consp
		ifFalse: 
			[structure := PrologStructure functor: structure terms: nil.
			clause car: structure].
	functor := structure car.
	functor isPrologVariable
		ifTrue: 
			[self call: clause car.
			^self].
	functor isBuiltInPredicate
		ifTrue: 
			[self builtInPredicate: functor.
			^self].
	definition := userPredicates at: functor ifAbsent: [systemPredicates at: functor
					ifAbsent: 
						[status := #back.
						^self]].
	status := #next! !

!PrologInterpreter methodsFor: 'private' stamp: ''!
makeSystemPredicates
	SystemPredicates isNil
		ifTrue: 
			[self systemPredicatesNo0.
			self systemPredicatesNo1.
			self systemPredicatesNo2.
			self systemPredicatesNo3.
			self systemPredicatesNo4.
			self systemPredicatesNo5.
			self systemPredicatesNo6.
			self systemPredicatesNo7.
			self systemPredicatesNo8.
			self systemPredicatesNo9.
			SystemPredicates := systemPredicates]
		ifFalse: [systemPredicates := SystemPredicates]! !

!PrologInterpreter methodsFor: 'public accessing' stamp: 'nsh 9/8/2008 00:28'!
modalFileSelectorWithCaption: caption 
	^ self class modalFileSelectorWithCaption: caption! !

!PrologInterpreter methodsFor: 'resolve modules' stamp: ''!
next
	| definitionEnv saveBackTrack array |
	definitionEnv := self nullEnv.
	definition cdr == nil
		ifTrue: 
			[(self
				unify: clause car cdr
				env: clauseEnv
				and: definition car car cdr
				env: definitionEnv)
				ifFalse: 
					[status := #back.
					^self].
			queue := clause cdr cons: queue.
			queueEnv := clauseEnv cons: queueEnv.
			clause := definition car cdr.
			clauseEnv := definitionEnv.
			cutBack := backTrack cons: cutBack.
			status := #loop.
			^self].
	saveBackTrack := backTrack.
	array := Array new: 7.
	array at: 1 put: clause.
	array at: 2 put: clauseEnv.
	array at: 3 put: queue.
	array at: 4 put: queueEnv.
	array at: 5 put: cutBack.
	array at: 6 put: definition cdr.
	array at: 7 put: unbindList.
	backTrack := array cons: saveBackTrack.
	(self
		unify: clause car cdr
		env: clauseEnv
		and: definition car car cdr
		env: definitionEnv)
		ifFalse: 
			[status := #back.
			^self].
	queue := clause cdr cons: queue.
	queueEnv := clauseEnv cons: queueEnv.
	clause := definition car cdr.
	clauseEnv := definitionEnv.
	cutBack := saveBackTrack cons: cutBack.
	status := #loop! !

!PrologInterpreter methodsFor: 'system predicates' stamp: ''!
nl
	textCollector cr.
	^true! !

!PrologInterpreter methodsFor: 'binding and unbinding' stamp: ''!
noValue: x env: xEnv 
	| assoc |
	x isPrologVariable
		ifTrue: 
			[assoc := self binding: x env: xEnv.
			assoc == nil ifTrue: [^true].
			assoc := assoc cdr.
			^self noValue: assoc car env: assoc cdr].
	^false! !

!PrologInterpreter methodsFor: 'system predicates' stamp: ''!
nospy: aPrologSymbol 
	| def |
	def := tracePredicates at: aPrologSymbol ifAbsent: [nil].
	def == nil ifTrue: [^false].
	userPredicates at: aPrologSymbol put: def.
	tracePredicates removeKey: aPrologSymbol.
	^true! !

!PrologInterpreter methodsFor: 'system predicates' stamp: ''!
notrace
	userPredicates associationsDo: [:assoc | self nospy: assoc key].
	^true! !

!PrologInterpreter methodsFor: 'binding and unbinding' stamp: ''!
nullEnv
	envCounter := envCounter + 1.
	^envCounter cons: nil! !

!PrologInterpreter methodsFor: 'system predicates' stamp: ''!
number: x
	^x isKindOf: Number! !

!PrologInterpreter methodsFor: 'interface opening' stamp: 'nsh 8/31/2008 03:12'!
open
	"PrologInterpreter open."

	| topView questionView transcriptView |
	Smalltalk isMorphic ifTrue: [^ self openAsMorph].
	topView := StandardSystemView new
			model: self;
			backgroundColor: Color white;
			label: 'Prolog';
			minimumSize: 250 @ 300.
	questionView := PluggableTextView on: self 
			text: #contents accept: #acceptWith:
			readSelection: #contentsSelection menu: #codePaneMenu:shifted:.
	questionView
			window: (0 @ 0 extent: 250 @ 100);
			borderWidth: 2;
			backgroundColor: Color lightYellow.
	transcriptView := PluggableTextView new
			model: self textCollector;
			window: (0 @ 0 extent: 250 @ 200);
			backgroundColor: Color white;
			borderWidthLeft: 2 right: 2 top: 0 bottom: 2. 

	topView addSubView: questionView.
	topView addSubView: transcriptView below: questionView.
	^ topView controller open.
! !

!PrologInterpreter methodsFor: 'interface opening' stamp: 'nsh 8/31/2008 08:48'!
openAsMorph
	"PrologInterpreter new openAsMorph."
	| topView questionView transcriptView |
	topView := (SystemWindow labelled: 'Prolog')
				model: self.
	topView setStripeColorsFrom: self defaultBackgroundColor.
	topView minimumExtent: 250 @ 300.
	questionView := PluggableTextMorph
				on: self
				text: #contents
				accept: #acceptWith:
				readSelection: #contentsSelection
				menu: #codePaneMenu:shifted:.
	questionView acceptOnCR: false.
	topView
		addMorph: questionView
		frame: (0 @ 0 corner: 1 @ 0.4).
	transcriptView := PluggableTextMorph
				on: self textCollector
				text: #contents
				accept: #contents:notifying:
				readSelection: nil
				menu: #codePaneMenu:shifted:.
	transcriptView acceptOnCR: false.
	topView
		addMorph: transcriptView
		frame: (0 @ 0.4 corner: 1 @ 1).
	[topView visible: false.
	topView openInWorld.
	topView extent: 250 @ 300]
		ensure: [topView visible: true].
	^ topView! !

!PrologInterpreter methodsFor: 'outputting' stamp: 'nishis 4/25/98 07:08'!
outputAnswer: dict 
	| anArray string assoc associations |
	associations := OrderedCollection new.
	dict associationsDo: [:association | associations add: association].
	anArray := associations asSortedCollection.
	1 to: anArray size do: [:i | 
		assoc := anArray at: i.
		i = 1
			ifTrue: [string := '']
			ifFalse: [string := ',\' withCRs].
		string := string , assoc key.
		string := string , ' = '.
		string := string , assoc value printPrologString.
		string := string , ' '.
		textCollector show: string]! !

!PrologInterpreter methodsFor: 'outputting' stamp: ''!
outputTime: msec 
	| goal string |
	verbose
		ifTrue: 
			[goal := envCounter - 1.
			string := '<'.
			string := string , msec printString , ' milliseconds, '.
			string := string , goal printString , ' goals'.
			string := string , '>\' withCRs.
			textCollector show: string asText]! !

!PrologInterpreter methodsFor: 'outputting' stamp: ''!
outputVariables: aDictionary
	| bool |
	self outputAnswer: aDictionary.
	bool := self confirm: 'All right ?'.
	bool
		ifTrue: [textCollector cr]
		ifFalse: [textCollector show: ';\' withCRs].
	^bool! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nsh 9/7/2008 21:05'!
pred
	"^ predicate"
	predicate isNil
		ifTrue: [^ 0].
	^ self predList indexOf: predicate string! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nsh 9/7/2008 22:07'!
pred: index 
	(index isNil
			or: [index isInteger not])
		ifTrue: [predicate := nil]
		ifFalse: [| selection | 
			(selection := self predList at: index ifAbsent: nil) isNil
				ifFalse: [
			predicate := PrologSymbol install: selection]].
	textValue := self listingText.
	self changed: #pred.
	self changed: #listingText.
	self changed: #editingText! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nsh 9/8/2008 06:06'!
predEditMenu: aMenu shifted: shifted 
	"PrologInterpreter flushMenus."
	^ aMenu
		labels: ('save\remove\update' withCRs findTokens: String cr asArray)
		lines: #()
		selections: #(#savePred #removePred #updatePredList )! !

!PrologInterpreter methodsFor: 'adaptor' stamp: ''!
predList
	| collection |
	collection := SortedCollection new.
	userPredicates associationsDo: [:assoc | collection add: assoc key string].
	^collection asArray! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nsh 9/8/2008 06:19'!
predListMenu: aMenu shifted: shifted 
	"PrologInterpreter flushMenus."
	^ aMenu
		labels: 'update'
		lines: #()
		selections: #(#updatePredList )! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nsh 9/8/2008 04:08'!
prologMenuOn: aMenu receiver: receiver controller: controller selection: selection
	aMenu add: 'do it (prolog)' target: self selector: #doIt:from: argumentList: (Array with:  selection asString with: controller).
	aMenu add: 'inspect it (prolog)' target: self selector: #inspectIt:from: argumentList: (Array with:  selection asString with: controller).
	aMenu addLine.
	aMenu add: 'listing' target: self selector: #listing argument: nil.
	aMenu add: 'editing' target: self selector: #editing argument: nil.
	aMenu addLine.
	aMenu add: 'consulting' target: self selector: #consulting argument: nil.
	aMenu add: 'reconsulting' target: self selector: #reconsulting argument: nil.
	aMenu add: 'file edit' target: self selector: #fileEdit argument: nil.
	aMenu add: 'saving' target: self selector: #saving argument: nil.
	aMenu addLine.
	aMenu add: 'read' target: self selector: #readFromUser argument: nil.
	aMenu add: 'trace' target: self selector: #traceWithUpdate argument: nil.
	aMenu addLine.
	aMenu add: 'gc' target: self selector: #gc argument: nil.
	aMenu add: 'investigate' target: self selector: #investigate argument: nil.
	aMenu add: '--- prolog ---' target: self selector: #toBeIgnored argument: nil.
	^ aMenu! !

!PrologInterpreter methodsFor: 'private' stamp: ''!
putCondition: condition 
	status := condition at: 1.
	definition := condition at: 2.
	question := condition at: 3.
	questionEnv := condition at: 4.
	clause := condition at: 5.
	clauseEnv := condition at: 6.
	queue := condition at: 7.
	queueEnv := condition at: 8.
	valueEnv := condition at: 9.
	unbindList := condition at: 10.
	cutBack := condition at: 11.
	backTrack := condition at: 12.
	resolveAction := condition at: 13.
	definitionStack := condition at: 14! !

!PrologInterpreter methodsFor: 'system predicates' stamp: ''!
read
	^self read: 'Type prolog expression followed by carriage return.'! !

!PrologInterpreter methodsFor: 'system predicates' stamp: 'nsh 9/8/2008 03:40'!
read: aMessage 
	| clipboardClass parser stream answer |
	clipboardClass := (Smalltalk respondsTo: #clipboardText)
				ifTrue: [Smalltalk]
				ifFalse: [Clipboard default].
	answer := FillInTheBlank request: aMessage initialAnswer: clipboardClass clipboardText.
	parser := PrologParser new.
	stream := ReadStream on: answer asString.
	parser
		init: stream
		ifFail: [:errorMessage | ^ self error: errorMessage].
	^ parser scanExpression! !

!PrologInterpreter methodsFor: 'menu messages' stamp: 'nsh 9/8/2008 03:54'!
readFromUser
	| result |
	(result := self read) notNil
		ifTrue: [self textCollector cr; nextPutAll: result printPrologString; flush]! !

!PrologInterpreter methodsFor: 'kernel predicates' stamp: ''!
receiver: receiverSymbol selector: selectorSymbol arguments: argumentList 
	| receiver size selector arguments list result index |
	((receiverSymbol isKindOf: PrologSymbol)
		and: [receiverSymbol isPrologSelf])
		ifTrue: [receiver := self]
		ifFalse: [receiver := receiverSymbol].
	(receiver isKindOf: PrologObject)
		ifTrue: [receiver := receiver object].
	size := selectorSymbol size.
	selector := String new: size.
	1 to: size do: [:i | selector at: i put: (selectorSymbol at: i)].
	selector := selector asSymbol.
	list := argumentList.
	list == nil
		ifTrue: 
			[arguments := Array new.
			result := receiver perform: selector]
		ifFalse: 
			[size := list length.
			arguments := Array new: size.
			1 to: size
				do: 
					[:i | 
					arguments at: i put: ((list car isKindOf: PrologObject)
							ifTrue: [list car object]
							ifFalse: [list car]).
					list := list cdr].
			result := receiver perform: selector withArguments: arguments].
	((result = true or: [result = false])
		or: [result isPrologEntity])
		ifTrue: [result := result yourself]
		ifFalse: 
			[list := PrologList car: receiverSymbol cdr: argumentList.
			index := (Array with: receiver)
						, arguments findFirst: [:each | each = result].
			index = 0
				ifTrue: [result := PrologObject source: result printString object: result]
				ifFalse: [result := list nth: index]].
	^result! !

!PrologInterpreter methodsFor: 'system predicates' stamp: 'nishis 4/27/98 05:22'!
reconsult
	| aModel |
	aModel := self copy.
	aModel perform: #reconsultingInterface.
	^true! !

!PrologInterpreter methodsFor: 'system support' stamp: ''!
reconsult: readStream action: aBlock
	| condition newPredicates parser node hornClause program functor stream result |
	condition := self getCondition.
	newPredicates := Dictionary new.
	parser := PrologParser new.
	result := true.
	[node := parser parse: readStream.
	node == #eof]
		whileFalse: 
			[hornClause := node cdr.
			node car
				ifTrue: 
					[stream := WriteStream on: (String new: 20).
					hornClause questionPrintPrologOn: stream.
					textCollector show: stream contents.
					textCollector cr.
					result := self resolve: hornClause action: aBlock]
				ifFalse: 
					[functor := hornClause car car.
					program := newPredicates at: functor ifAbsent: [].
					program == nil
						ifTrue: 
							[program := PrologDefinition fromList: (hornClause cons: nil).
							newPredicates at: functor put: program]
						ifFalse: [program nconc: (hornClause cons: nil)].
					userPredicates at: functor put: program]].
	newPredicates keys
		do: [:eachPredicate |
			userPredicates at: eachPredicate put: (newPredicates at: eachPredicate).
			tracePredicates removeKey: eachPredicate ifAbsent: []].
	self putCondition: condition.
	^result! !

!PrologInterpreter methodsFor: 'system predicates' stamp: 'nsh 9/8/2008 02:58'!
reconsultFile: fileName 
	| aFileStream |
	(fileName respondsTo: #asString)
		ifFalse: [^ false].
	(FileDirectory default fileExists: fileName)
		ifTrue: [textCollector show: '<reconsult from ' , fileName asString , '>\' withCRs.
			aFileStream := FileStream oldFileNamed: fileName.
			[self reconsult: aFileStream action: nil]
				ensure: [aFileStream close].
			^ true]
		ifFalse: [^ false]! !

!PrologInterpreter methodsFor: 'menu messages' stamp: 'nsh 9/8/2008 02:33'!
reconsulting
	| prompt aFileName |
	prompt := 'Please type a name for reconsulting file.' translated.
	aFileName := Smalltalk isMorphic
				ifTrue: [| aFileStream | (aFileStream := self modalFileSelectorWithCaption: prompt) notNil
						ifTrue: [aFileStream name]]
				ifFalse: [| selection | (selection := PrologPluggableFileList newFilePrompt: prompt) notNil
						ifTrue: [selection directory fullNameFor: selection name]].
	(aFileName isNil or: [aFileName asString isEmpty or: [aFileName asString = 'user']])
		ifTrue: [^self reconsult]
		ifFalse: [^self reconsultFile: aFileName asString]! !

!PrologInterpreter methodsFor: 'interface opening' stamp: 'nsh 9/8/2008 06:13'!
reconsultingInterface
	| copySelf topView textView |
	Smalltalk isMorphic ifTrue: [^ self reconsultingInterfaceAsMorph].
	copySelf := self copy.
	topView := StandardSystemView new
			model: copySelf;
			backgroundColor: Color white;
			label: 'Prolog Reconsultant';
			minimumSize: 250 @ 200.
	textView := PluggableTextView on: copySelf 
			text: #reconsultingTextValue accept: #reconsultingTextValueChange:
			readSelection: #contentsSelection menu: #reconsultingTextMenu:shifted:.
	textView
			window: (0 @ 0 extent: 250 @ 200);
			borderWidth: 2; 
			backgroundColor: Color lightYellow.
	topView addSubView: textView.
	topView  controller open! !

!PrologInterpreter methodsFor: 'interface opening' stamp: 'nsh 9/8/2008 06:12'!
reconsultingInterfaceAsMorph
	| copySelf topView textView |
	copySelf := self copy.
	topView := (SystemWindow labelled: 'Prolog Reconsultant') model: copySelf.
	topView setStripeColorsFrom: self defaultBackgroundColor.
	topView minimumExtent: 250 @ 200.
	textView := PluggableTextMorph on: copySelf 
			text: #reconsultingTextValue accept: #reconsultingTextValueChange:
			"change: #reconsultingTextValueChange: "
			readSelection: nil menu: #reconsultingTextMenu:shifted:.
	textView acceptOnCR: true.
	topView 
		addMorph: textView
		frame: (0 @ 0 corner: 1 @ 1).
	[ topView visible: false.
	topView openInWorld.
	topView extent: 250 @ 200 ] ensure: [ topView visible: true ].
	^ topView! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nsh 9/8/2008 06:14'!
reconsultingTextMenu: aMenu shifted: shifted 
	^ self editingMenu: aMenu shifted: shifted! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nishis 5/3/98 06:54'!
reconsultingTextValue
	textValue isNil ifTrue: [textValue := Text new].
	^textValue! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nishis 5/3/98 10:56'!
reconsultingTextValueChange: aText 
	self acceptReconsulting: aText! !

!PrologInterpreter methodsFor: 'public accessing' stamp: ''!
refute: stringOrStream
	^self refute: stringOrStream action: [:answer | ^answer]! !

!PrologInterpreter methodsFor: 'public accessing' stamp: ''!
refute: stringOrStream action: aBlock 
	| stream |
	(stringOrStream isKindOf: Stream)
		ifTrue: [stream := ReadStream on: stringOrStream contents]
		ifFalse: [stream := ReadStream on: stringOrStream].
	^self consult: stream action: aBlock! !

!PrologInterpreter methodsFor: 'system predicates' stamp: ''!
remove
	userPredicates keys do: 
		[:aPrologSymbol | 
		userPredicates removeKey: aPrologSymbol ifAbsent: [].
		tracePredicates removeKey: aPrologSymbol ifAbsent: []].
	^true! !

!PrologInterpreter methodsFor: 'system predicates' stamp: ''!
remove: aPrologSymbol
	userPredicates removeKey: aPrologSymbol ifAbsent: [^false].
	tracePredicates removeKey: aPrologSymbol ifAbsent: [].
	^true! !

!PrologInterpreter methodsFor: 'menu messages' stamp: ''!
removePred
	predicate == nil ifTrue: [^self].
	(self confirm: 'Do you really want to remove?')
		ifTrue: 
			[self remove: predicate.
			self updatePredList]! !

!PrologInterpreter methodsFor: 'representation' stamp: ''!
represent: x env: xEnv 
	| assoc a d |
	x isPrologVariable
		ifTrue: 
			[assoc := self binding: x env: xEnv.
			assoc == nil ifTrue: [^self variableRepresent: x env: xEnv].
			assoc := assoc cdr.
			^self represent: assoc car env: assoc cdr].
	(x consp) ifFalse: [^x].
	a := self represent: x car env: xEnv.
	d := self represent: x cdr env: xEnv.
	^x class car: a cdr: d! !

!PrologInterpreter methodsFor: 'resolution' stamp: ''!
resolve: goal 
	^self resolve: goal action: nil! !

!PrologInterpreter methodsFor: 'resolution' stamp: ''!
resolve: goal action: actionBlock
	| result |
	question := clause := goal.
	actionBlock == nil
		ifTrue: [resolveAction := [:dict | self outputVariables: dict]]
		ifFalse: [resolveAction := actionBlock].
	Cursor execute
		showWhile: 
			[self resolveInitialize.
			self resolveLoop.
			result := self resolveTerminate].
	^result! !

!PrologInterpreter methodsFor: 'resolution' stamp: ''!
resolveInitialize
	status := #loop.
	envCounter := 0.
	questionEnv := clauseEnv := self nullEnv.
	queue := queueEnv := valueEnv := nil.
	unbindList := cutBack := backTrack := nil.
	definitionStack := nil.
	traceCounter := 0! !

!PrologInterpreter methodsFor: 'resolution' stamp: ''!
resolveLoop
	| totalTime time answer |
	totalTime := 0.
	time := Time millisecondClockValue.
	[true]
		whileTrue: 
			[status == #loop ifTrue: [self loop].
			status == #next ifTrue: [self next].
			status == #back ifTrue: [self back].
			status == #succ
				ifTrue: 
					[time := Time millisecondClockValue - time.
					self outputTime: (totalTime := totalTime + time).
					answer := self collectVariables.
					answer isEmpty ifTrue: [^true].
					(resolveAction value: answer)
						ifTrue: [^true]
						ifFalse: 
							[status := #back.
							time := Time millisecondClockValue]].
			status == #fail
				ifTrue: 
					[time := Time millisecondClockValue - time.
					self outputTime: (totalTime := totalTime + time).
					^false]]! !

!PrologInterpreter methodsFor: 'resolution' stamp: ''!
resolveTerminate
	Cursor wait
		showWhile: 
			[self deallocateEnv: questionEnv].
	status == #succ
		ifTrue: 
			[textCollector show: 'yes'.
			textCollector cr.
			^true].
	status == #fail
		ifTrue: 
			[textCollector show: 'no'.
			textCollector cr.
			^false].
	self error: 'Unexpected status'! !

!PrologInterpreter methodsFor: 'system predicates' stamp: ''!
retract: aPrologClause 
	| count horn def functor prev result |
	count := 0.
	horn := aPrologClause.
	horn consp
		ifFalse: 
			[horn := PrologStructure functor: horn terms: nil.
			count := count + 1].
	horn car consp
		ifFalse: 
			[horn := PrologClause head: horn body: nil.
			count := count + 1].
	horn := PrologClause head: horn car body: (PrologBody fromList: horn cdr).
	functor := horn car car.
	prev := def := userPredicates at: functor ifAbsent: [^PrologSymbol cut].
	[def consp]
		whileTrue: [(self
				unify: horn
				env: self nullEnv
				and: def car
				env: self nullEnv)
				ifTrue: 
					[result := def car.
					count timesRepeat: [result := result car].
					prev == def
						ifTrue: 
							[def cdr isNil
								ifTrue: [userPredicates removeKey: functor ifAbsent: [nil]]
								ifFalse: [userPredicates at: functor put: def cdr].
							^result]
						ifFalse: 
							[prev cdr: def cdr.
							^result]]
				ifFalse: 
					[prev := def.
					def := def cdr]].
	^PrologSymbol cut! !

!PrologInterpreter methodsFor: 'system support' stamp: 'nsh 9/7/2008 23:37'!
saveOn: fileName 
	| aFileStream def |
	aFileStream := FileStream fileNamed: fileName.
	[(self associations: userPredicates) asSortedCollection
		do: [:assoc | 
			def := assoc value.
			[def consp]
				whileTrue: [aFileStream nextPutAll: def car prettyPrintPrologString , '\' withCRs.
					def := def cdr]]]
		ensure: [aFileStream close]! !

!PrologInterpreter methodsFor: 'system support' stamp: 'nsh 9/7/2008 23:36'!
saveOn: fileName predicateName: aPrologSymbol 
	| aFileStream def |
	aFileStream := FileStream fileNamed: fileName.
	[def := userPredicates
				at: aPrologSymbol
				ifAbsent: [].
	def == nil
		ifFalse: [[def consp]
				whileTrue: [aFileStream nextPutAll: def car prettyPrintPrologString , '\' withCRs.
					def := def cdr]]]
		ensure: [aFileStream close]! !

!PrologInterpreter methodsFor: 'menu messages' stamp: ''!
savePred
	predicate == nil ifTrue: [^self].
	self saving: predicate! !

!PrologInterpreter methodsFor: 'system predicates' stamp: 'nsh 9/8/2008 02:26'!
saving
	| prompt aFileName |
	prompt := 'Please select a name, or add new file, for saving.' translated.
	aFileName := Smalltalk isMorphic
				ifTrue: [| aFileStream | (aFileStream := self modalFileSelectorWithCaption: prompt) notNil
						ifTrue: [aFileStream name]]
				ifFalse: [| selection | (selection := PrologPluggableFileList newFilePrompt: prompt) notNil
						ifTrue: [selection directory fullNameFor: selection name]].
	(aFileName isNil
			or: [aFileName isEmpty])
		ifTrue: [^ false].
	Cursor write
		showWhile: [self saveOn: aFileName asString].
	^ true! !

!PrologInterpreter methodsFor: 'system predicates' stamp: 'nsh 9/8/2008 02:26'!
saving: aPrologSymbol 
	| def prompt aFileName |
	def := tracePredicates
				at: aPrologSymbol
				ifAbsent: [userPredicates
						at: aPrologSymbol
						ifAbsent: []].
	def == nil
		ifTrue: [^ false].
	prompt := 'Please select a name, or add new file, for saving.' translated.
	aFileName := Smalltalk isMorphic
				ifTrue: [| aFileStream | (aFileStream := self modalFileSelectorWithCaption: prompt) notNil
						ifTrue: [aFileStream name]]
				ifFalse: [| selection | (selection := PrologPluggableFileList newFilePrompt: prompt) notNil
						ifFalse: [selection directory fullNameFor: selection name]].
	(aFileName isNil
			or: [aFileName isEmpty])
		ifTrue: [^ false].
	self saveOn: aFileName predicateName: aPrologSymbol.
	^ true! !

!PrologInterpreter methodsFor: 'copying' stamp: 'nishis 5/3/98 06:49'!
shallowCopy
	super shallowCopy.
	textValue := nil.
	listValue := nil.
	predicate := nil! !

!PrologInterpreter methodsFor: 'system predicates' stamp: ''!
spy: aPrologSymbol 
	| def reverseClone tracedef |
	def := userPredicates at: aPrologSymbol ifAbsent: [nil].
	def == nil ifTrue: [^false].
	(tracePredicates at: aPrologSymbol ifAbsent: [nil]) isNil ifFalse: [^true].
	tracePredicates at: aPrologSymbol put: def.
	reverseClone := nil.
	[def consp]
		whileTrue: 
			[reverseClone := def car cons: reverseClone.
			def := def cdr].
	tracedef := nil.
	[reverseClone consp]
		whileTrue: 
			[tracedef := (self traceFailClause: reverseClone car car)
						cons: tracedef.
			tracedef := (self traceExitClause: reverseClone car)
						cons: tracedef.
			reverseClone cdr consp
				ifTrue: [tracedef := (self traceRedoClause: reverseClone car car)
								cons: tracedef]
				ifFalse: [tracedef := (self traceCallClause: reverseClone car car)
								cons: tracedef].
			reverseClone := reverseClone cdr].
	userPredicates at: aPrologSymbol put: (PrologDefinition fromList: tracedef).
	^true! !

!PrologInterpreter methodsFor: 'system predicates' stamp: ''!
strToSym: listOrString 
	| stream string token s |
	listOrString consp
		ifTrue: 
			[s := WriteStream on: (String new: 16).
			listOrString do: [:char | s nextPut: (Character value: char)].
			string := s contents]
		ifFalse: [string := listOrString string].
	stream := ReadStream on: string.
	token := (PrologScanner new on: stream) nextToken.
	((self number: token)
		and: [stream atEnd])
		ifTrue: [^token]
		ifFalse: [string = '[]'
				ifTrue: [^nil]
				ifFalse: [^PrologSymbol install: string]]! !

!PrologInterpreter methodsFor: 'system predicates' stamp: ''!
string: x
	^x class == PrologString! !

!PrologInterpreter methodsFor: 'system predicates' stamp: 'nishis 6/28/1998 06:25'!
symToList: numOrSym 
	| pstring |
	pstring := self symToStr: numOrSym.
	^PrologList list: pstring string asByteArray! !

!PrologInterpreter methodsFor: 'system predicates' stamp: ''!
symToStr: numOrSym 
	numOrSym isNil ifTrue: [^PrologString fromString: '[]'].
	(self number: numOrSym)
		ifTrue: [^PrologString fromString: numOrSym printString].
	^PrologString fromString: numOrSym string! !

!PrologInterpreter methodsFor: 'system predicates' stamp: ''!
symbol: x
	^x class == PrologSymbol! !

!PrologInterpreter methodsFor: 'system support' stamp: ''!
systemConsult: readStream 
	| condition parser node hornClause program functor |
	condition := self getCondition.
	parser := PrologParser new.
	[node := parser parse: readStream.
	node == #eof]
		whileFalse: 
			[hornClause := node cdr.
			node car
				ifTrue: [self resolve: hornClause]
				ifFalse: 
					[functor := hornClause car car.
					program := systemPredicates at: functor ifAbsent: [].
					program == nil
						ifTrue: 
							[program := PrologDefinition fromList: (hornClause cons: nil).
							systemPredicates at: functor put: program]
						ifFalse: [program nconc: (hornClause cons: nil)]]].
	self putCondition: condition.
	^true! !

!PrologInterpreter methodsFor: 'system predicates' stamp: 'nishis 5/3/98 08:09'!
systemListing
	| predicateName |
	(self associations: systemPredicates) asSortedCollection
		do: 
			[:assoc | 
			predicateName := assoc key.
			((predicateName respondsTo: #asString)
				and: [predicateName string isEmpty not and: [predicateName string first = $~]])
				ifFalse: [self systemListing: predicateName]].
	^true! !

!PrologInterpreter methodsFor: 'system predicates' stamp: ''!
systemListing: aPrologSymbol
	| def |
	def := systemPredicates at: aPrologSymbol ifAbsent: [nil].
	def == nil ifTrue: [^false].
	[def consp]
			whileTrue: 
				[textCollector show: def car prettyPrintPrologString , '\' withCRs.
				def := def cdr].
	^true! !

!PrologInterpreter methodsFor: 'system predicates' stamp: 'nishis 5/3/98 08:08'!
systemPredicates
	| collection list |
	collection := (self associations: systemPredicates) asSortedCollection.
	list := nil.
	collection reverseDo: [:each | ((each key respondsTo: #asString)
			and: [each key string isEmpty not and: [each key string first = $~]])
			ifTrue: ['not adding: invisible predicate' yourself]
			ifFalse: [list := each key cons: list]].
	^list! !

!PrologInterpreter methodsFor: 'private' stamp: ''!
systemPredicatesNo0
	"PrologInterpreter flushSystemPredicates."

	self systemReconsult: (ReadStream on: '
		!! :- builtin.
		true :- builtin.
		fail :- builtin.
		var(X) :- builtin.
		send(X,Y,Z) :- bulitin.
		send(X,Y,Z,A) :- bulitin.
	')! !

!PrologInterpreter methodsFor: 'private' stamp: ''!
systemPredicatesNo1
	"PrologInterpreter flushSystemPredicates."

	self systemReconsult: (ReadStream on: '
		repeat.
		repeat :- repeat.
		nonvar(X) :- var(X), !!, fail.
		nonvar(X).
		integer(X) :- send(self,integer:,[X]).
		float(X) :- send(self,float:,[X]).
		double(X) :- send(self,double:,[X]).
		fraction(X) :- send(self,fraction:,[X]).
		number(X) :- send(self,number:,[X]).
		symbol(X) :- send(self,symbol:,[X]).
		string(X) :- send(self,string:,[X]).
		list(X) :- send(self,list:,[X]).
		dotp(X) :- send(self,dotp:,[X]).
		atom(X) :- symbol(X).
		atom(X) :- nonvar(X), =(X,[]).
		atom(X) :- string(X).
		atomic(X) :- atom(X).
		atomic(X) :- number(X).
		structure(X) :- nonvar(X), not(atomic(X)).
	')! !

!PrologInterpreter methodsFor: 'private' stamp: ''!
systemPredicatesNo2
	"PrologInterpreter flushSystemPredicates."

	self systemReconsult: (ReadStream on: '
		==(X,Y) :- send(X,=,[Y]).
		\==(X,Y) :- ==(X,Y), !!, fail.
		\==(X,Y).
		=(X,X).
		\=(X,Y) :- =(X,Y), !!, fail.
		\=(X,Y).
		>(X,Y) :- send(X,>,[Y]).
		>=(X,Y) :- send(X,>=,[Y]).
		<(X,Y) :- send(X,<,[Y]).
		=<(X,Y) :- send(X,<=,[Y]).
	')! !

!PrologInterpreter methodsFor: 'private' stamp: ''!
systemPredicatesNo3
	"PrologInterpreter flushSystemPredicates."

	self systemReconsult: (ReadStream on: '
		+(X,Y,Z) :- send(X,+,[Y],Z).
		-(X,Y,Z) :- send(X,-,[Y],Z).
		*(X,Y,Z) :- send(X,*,[Y],Z).
		//(X,Y,Z) :- send(X,//,[Y],Z).
		/(X,Y,Z) :- send(X,/,[Y],Z).
		\\(X,Y,Z) :- send(X,\\,[Y],Z).
		is(Z,+(X,Y)) :- nonvar(Z), nonvar(X), nonvar(Y), send(X,+,[Y],Z).
		is(Z,+(X,Y)) :- var(Z), nonvar(X), nonvar(Y), send(X,+,[Y],Z).
		is(Z,+(X,Y)) :- var(X), nonvar(Y), nonvar(Z), send(Z,-,[Y],X).
		is(Z,+(X,Y)) :- var(Y), nonvar(Z), nonvar(X), send(Z,-,[X],Y).
		is(Z,-(X,Y)) :- nonvar(Z), nonvar(X), nonvar(Y), send(X,-,[Y],Z).
		is(Z,-(X,Y)) :- var(Z), nonvar(X), nonvar(Y), send(X,-,[Y],Z).
		is(Z,-(X,Y)) :- var(X), nonvar(Y), nonvar(Z), send(Z,+,[Y],X).
		is(Z,-(X,Y)) :- var(Y), nonvar(Z), nonvar(X), send(X,-,[Z],Y).
		is(Z,*(X,Y)) :- nonvar(Z), nonvar(X), nonvar(Y), send(X,*,[Y],Z).
		is(Z,*(X,Y)) :- var(Z), nonvar(X), nonvar(Y), send(X,*,[Y],Z).
		is(Z,*(X,Y)) :- var(X), nonvar(Y), nonvar(Z), send(Z,/,[Y],X).
		is(Z,*(X,Y)) :- var(Y), nonvar(Z), nonvar(X), send(Z,/,[X],Y).
		is(Z,/(X,Y)) :- nonvar(Z), nonvar(X), nonvar(Y), send(X,/,[Y],Z).
		is(Z,/(X,Y)) :- var(Z), nonvar(X), nonvar(Y), send(X,/,[Y],Z).
		is(Z,/(X,Y)) :- var(X), nonvar(Y), nonvar(Z), send(Z,*,[Y],X).
		is(Z,/(X,Y)) :- var(Y), nonvar(Z), nonvar(X), send(X,/,[Z],Y).
		is(X,Y) :- =(X,Y).
	')! !

!PrologInterpreter methodsFor: 'private' stamp: ''!
systemPredicatesNo4
	"PrologInterpreter flushSystemPredicates."

	self systemReconsult: (ReadStream on: '
		listing :- send(self,userListing,[]).
		listing(X) :- send(self,userListing:,[X]).
		systemListing :- send(self,systemListing,[]).
		systemListing(X) :- send(self,systemListing:,[X]).
		editing :- send(self,editting,[]).
		consult :- send(self,consult,[]).
		consult(X) :- nonvar(X), send(self,consultFile:,[X]).
		reconsult :- send(self,reconsult,[]).
		reconsult(X) :- nonvar(X), send(self,reconsultFile:,[X]).
		saving :- send(self,saving,[]).
		saving(X) :- send(self,saving:,[X]).
		userPredicates(X) :- send(self,userPredicates,[],X).
		systemPredicates(X) :- send(self,systemPredicates,[],X).
		predicates([X|Y]) :- userPredicates(X), systemPredicates(Y).
		functor(T,F,A) :- nonvar(T), !!, send(self,functorArityOf:,[T],[F|A]).
		functor(T,F,A) :- number(F), !!, =(0,A),=(T,F).
		functor(T,F,A) :- atom(F), =<(0,A), ''~addvar''([F],A,L), =..(T,L).
		''~addvar''(L,0,M) :- !!, =(L,M).
		''~addvar''(L,NVars,M) :- -(NVars, 1, N), append(L,[FreeV],LV), ''~addvar''(LV,N,M).
		arg(Nth,S,T) :- integer(Nth), <(0,Nth), structure(S), =..(S,[F|L]), nth(L,Nth,T).
		=..(X,Y) :- send(self,univ:,[[''X''|''Y'']]).
		name(X,Y) :- atomic(X), list(Y), !!, send(self,symToList:,[X],Y).
		name(X,Y) :- atomic(X), !!, send(self,symToStr:,[X],Y).
		name(X,Y) :- var(X), !!, nonvar(Y), send(self, strToSym:,[Y],X).
		remove :- send(self,remove,[]).
		remove(X) :- send(self,remove:,[X]).
		clause(X) :- send(self,clauseSet:,[X]), repeat, send(self,clause:,[X],X).
		asserta(X) :- send(self,asserta:,[X]).
		assert(X) :- send(self,assertz:,[X]).
		assertz(X) :- send(self,assertz:,[X]).
		retract(X) :- repeat, send(self,retract:,[X],X).
	')! !

!PrologInterpreter methodsFor: 'private' stamp: ''!
systemPredicatesNo5
	"PrologInterpreter flushSystemPredicates."

	self systemReconsult: (ReadStream on: '
		call(G) :- G.
		not(G) :- G, !!, fail.
		not(G).
		or(X,Y) :- call(X).
		or(X,Y) :- call(Y).
		and(X,Y) :- call(X), call(Y).
	')! !

!PrologInterpreter methodsFor: 'private' stamp: ''!
systemPredicatesNo6
	"PrologInterpreter flushSystemPredicates."

	self systemReconsult: (ReadStream on: '
		read(X) :- send(self,read,[],X).
		read(X,M) :- send(self,read:,[M],X).
		write(X) :- send(self,write:,[X]).
		nl :- send(self,nl,[]).
		tab(X) :- number(X), send(self,tab:,[X]).
		clear :- send(self,clear,[]).
	')! !

!PrologInterpreter methodsFor: 'private' stamp: ''!
systemPredicatesNo7
	"PrologInterpreter flushSystemPredicates."

	self systemReconsult: (ReadStream on: '
		clock(X) :- send({Time},millisecondClockValue,[],X).
		verbose(X) :- send(self,verbose:,[X]).
		gc :- send(self,gc,[]).
		inspect(X) :- send(X,inspect,[]).
		spy(X) :- send(self,spy:,[X]).
		nospy(X) :- send(self,nospy:,[X]).
		trace :- send(self,trace,[]).
		notrace :- send(self,notrace,[]).
	')! !

!PrologInterpreter methodsFor: 'private' stamp: ''!
systemPredicatesNo8
	"PrologInterpreter flushSystemPredicates."

	self systemReconsult: (ReadStream on: '
		append([],X,X).
		append([A|X],Y,[A|Z]) :- append(X,Y,Z).
		member(X,[X|Y]).
		member(X,[Y|Z]) :- member(X,Z).
		reverse([],[]).
		reverse([H|T],L) :- reverse(T,Z), append(Z,[H],L).
		length(X,Y) :- send(self,length:,[X],Y).
		nth([X|Y],1,Z) :- !!, =(X,Z).
		nth([X|Y],N,Z) :- -(N,1,PN), nth(Y,PN,Z).
		printlist(L) :- send(self,listPrint:,[L]).
		lispAppend(X,Y,Z) :- send(X,append:,[Y],Z).
		lispReverse(X,Y) :- send(X,reverse,[],Y).
		lispMember(X,Y) :- send(Y,member:,[X],A), \=(A,[]).
		lispMember(X,Y,Z) :- send(Y,member:,[X],Z).
		lispAssoc(X,Y) :- send(Y,assoc:,[X],A), \=(A,[]).
		lispAssoc(X,Y,Z) :- send(Y,assoc:,[X],Z).
		lispNconc(X,Y,Z) :- send(X,nconc:,[Y],Z).
	')! !

!PrologInterpreter methodsFor: 'private' stamp: ''!
systemPredicatesNo9
	"PrologInterpreter flushSystemPredicates."

	self systemReconsult: (ReadStream on: '
		%
		%	User System Predicates
		%
	')! !

!PrologInterpreter methodsFor: 'system support' stamp: ''!
systemReconsult: readStream 
	| condition newPredicates parser node hornClause program functor |
	condition := self getCondition.
	newPredicates := Dictionary new.
	parser := PrologParser new.
	[node := parser parse: readStream.
	node == #eof]
		whileFalse: 
			[hornClause := node cdr.
			node car
				ifTrue: [self resolve: hornClause]
				ifFalse: 
					[functor := hornClause car car.
					program := newPredicates at: functor ifAbsent: [].
					program == nil
						ifTrue: 
							[program := PrologDefinition fromList: (hornClause cons: nil).
							newPredicates at: functor put: program]
						ifFalse: [program nconc: (hornClause cons: nil)].
					systemPredicates at: functor put: program]].
	newPredicates keys do: [:eachPredicate | systemPredicates at: eachPredicate put: (newPredicates at: eachPredicate)].
	self putCondition: condition.
	^true! !

!PrologInterpreter methodsFor: 'system predicates' stamp: ''!
tab: aNumber 
	| spaces |
	(aNumber isKindOf: Number)
		ifFalse: [^false].
	spaces := String new.
	aNumber asInteger timesRepeat: [spaces := spaces , ' '].
	textCollector show: spaces.
	^true! !

!PrologInterpreter methodsFor: 'accessing' stamp: ''!
textCollector
	^textCollector! !

!PrologInterpreter methodsFor: 'accessing' stamp: ''!
textCollector: aTextCollector 
	textCollector := aTextCollector! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nishis 5/3/98 11:15'!
textValue
	textValue isNil ifTrue: [textValue := String new].
	^textValue! !

!PrologInterpreter methodsFor: 'resolve modules' stamp: 'nsh 8/31/2008 08:43'!
toBeIgnored
	self inform: 'AOKI Prolog for '
			, (Smalltalk isMorphic
					ifTrue: ['Morph']
					ifFalse: ['Squeak'])! !

!PrologInterpreter methodsFor: 'system predicates' stamp: ''!
trace
	userPredicates associationsDo: [:assoc | self spy: assoc key].
	^true! !

!PrologInterpreter methodsFor: 'system support' stamp: ''!
trace: para head: head arguments: terms 
	| headString numberString structure arguString |
	headString := (self expression: head env: clauseEnv) printPrologString.
	para = 0
		ifTrue: 
			[traceCounter := traceCounter + 1.
			numberString := String new: traceCounter withAll: $|.
			structure := PrologStructure functor: head car terms: terms.
			arguString := (self expression: structure env: clauseEnv) printPrologString.
			headString := headString , ' ~ ' , arguString.
			textCollector show: numberString , ' CALL : ' , headString , '\' withCRs.
			^self].
	para = 1
		ifTrue: 
			[traceCounter := traceCounter + 1.
			numberString := String new: traceCounter withAll: $|.
			structure := PrologStructure functor: head car terms: terms.
			arguString := (self expression: structure env: clauseEnv) printPrologString.
			headString := headString , ' ~ ' , arguString.
			textCollector show: numberString , ' REDO : ' , headString , '\' withCRs.
			^self].
	para = 2
		ifTrue: 
			[numberString := String new: traceCounter withAll: $|.
			textCollector show: numberString , ' FAIL : ' , headString , '\' withCRs.
			traceCounter := traceCounter - 1.
			^self].
	para = 3
		ifTrue: 
			[numberString := String new: traceCounter withAll: $|.
			textCollector show: numberString , ' EXIT : ' , headString , '\' withCRs.
			^self]! !

!PrologInterpreter methodsFor: 'system support' stamp: ''!
traceCallClause: head
	^self traceClause: head flag: 0! !

!PrologInterpreter methodsFor: 'system support' stamp: ''!
traceClause: head flag: anInteger 
	| arguVar headStruct failStruct traceStruct |
	arguVar := PrologVariable install: 'Arguments'.
	headStruct := PrologStructure functor: head car terms: arguVar.
	failStruct := PrologStructure functor: (PrologSymbol install: 'fail')
				terms: nil.
	traceStruct := arguVar cons: nil.
	traceStruct := head cons: traceStruct.
	traceStruct := anInteger cons: traceStruct.
	traceStruct := traceStruct cons: nil.
	traceStruct := (PrologSymbol install: 'trace:head:arguments:')
				cons: traceStruct.
	traceStruct := (PrologSymbol install: 'self')
				cons: traceStruct.
	traceStruct := PrologTerms fromList: traceStruct.
	traceStruct := PrologStructure functor: (PrologSymbol install: 'send')
				terms: traceStruct.
	anInteger = 3 ifTrue: [^PrologClause head: headStruct body: (PrologBody fromList: (traceStruct cons: nil))].
	^PrologClause head: headStruct body: (PrologBody fromList: (traceStruct cons: (failStruct cons: nil)))! !

!PrologInterpreter methodsFor: 'system support' stamp: ''!
traceExitClause: exitClause
	| traceExitClause reverseClone| 
	traceExitClause := self traceExitClauseAux: exitClause car.
	traceExitClause := traceExitClause cdr.
	reverseClone := exitClause reverse.
	[reverseClone consp]
		whileTrue:
			[traceExitClause := reverseClone car cons: traceExitClause.
			reverseClone := reverseClone cdr].
	^PrologClause head: traceExitClause car body: (PrologBody fromList: traceExitClause cdr)! !

!PrologInterpreter methodsFor: 'system support' stamp: ''!
traceExitClauseAux: head
	^self traceClause: head flag: 3! !

!PrologInterpreter methodsFor: 'system support' stamp: ''!
traceFailClause: head
	^self traceClause: head flag: 2! !

!PrologInterpreter methodsFor: 'system support' stamp: ''!
traceRedoClause: head
	^self traceClause: head flag: 1! !

!PrologInterpreter methodsFor: 'menu messages' stamp: 'nsh 9/8/2008 03:36'!
traceWithUpdate
	self trace.
	self textCollector cr; nextPutAll: self listingText; flush.
	self updatePredList! !

!PrologInterpreter methodsFor: 'binding and unbinding' stamp: ''!
unbindFrom: start to: end 
	| list env assocList |
	list := start.
	[list ~~ end]
		whileTrue: 
			[env := list car.
			assocList := env cdr.
			assocList car cdr cdr: nil.
			env cdr: assocList cdr.
			list := list cdr]! !

!PrologInterpreter methodsFor: 'unification' stamp: ''!
unify: x env: xEnv and: y env: yEnv 
	| xx yy assoc |
	xx := x.
	yy := y.
	[true]
		whileTrue: 
			[xEnv == yEnv ifTrue: [x = y ifTrue: [^true]].
			xx isPrologVariable ifTrue: [(assoc := self binding: xx env: xEnv) ~~ nil
					ifTrue: 
						[valueEnv := xEnv.
						assoc := assoc cdr.
						xx := self fetchValue: assoc car env: assoc cdr.
						^self
							unify: xx
							env: valueEnv
							and: yy
							env: yEnv]
					ifFalse: 
						[yy isPrologVariable ifTrue: [(assoc := self binding: yy env: yEnv) ~~ nil
								ifTrue: 
									[valueEnv := yEnv.
									assoc := assoc cdr.
									yy := self fetchValue: assoc car env: assoc cdr.
									^self
										unify: xx
										env: xEnv
										and: yy
										env: valueEnv]].
						self
							bind: xx
							env: xEnv
							and: yy
							env: yEnv.
						^true]].
			yy isPrologVariable
				ifTrue: 
					[(assoc := self binding: yy env: yEnv) ~~ nil
						ifTrue: 
							[valueEnv := yEnv.
							assoc := assoc cdr.
							yy := self fetchValue: assoc car env: assoc cdr.
							^self
								unify: xx
								env: xEnv
								and: yy
								env: valueEnv].
					self
						bind: yy
						env: yEnv
						and: xx
						env: xEnv.
					^true].
			xx consp ifFalse: [^xx = yy].
			yy consp ifFalse: [^yy = xx].
			(self
				unify: xx car
				env: xEnv
				and: yy car
				env: yEnv)
				ifFalse: [^false].
			xx := xx cdr.
			yy := yy cdr]! !

!PrologInterpreter methodsFor: 'system predicates' stamp: ''!
univ: aPrologList 
	| termv listv termValue termEnv listVal listEnv functor functorEnv terms newterms newStruct car t list |
	termv := PrologVariable install: aPrologList car string.
	listv := PrologVariable install: aPrologList cdr string.
	termValue := self fetchValue: termv env: clauseEnv.
	termEnv := valueEnv.
	listVal := self fetchValue: listv env: clauseEnv.
	listEnv := valueEnv.
	termValue isPrologVariable
		ifTrue: 
			["construct a term from fixed length list."
			listVal isPrologVariable ifTrue: [^false].
			listVal consp ifFalse: [^false].
			functor := self fetchValue: listVal car env: listEnv.
			functorEnv := valueEnv.
			terms := self fetchValue: listVal cdr env: listEnv.
			listEnv := valueEnv.
			(self number: functor)
				ifTrue: 
					[terms isNil ifFalse: [^false].
					self
						bind: termValue
						env: termEnv
						and: functor
						env: listEnv.
					^true].
			functor consp ifTrue: ["It's a structure or a list"
				^false].
			terms isNil
				ifTrue: 
					[self
						bind: termValue
						env: termEnv
						and: functor
						env: functorEnv.
					^true].
			terms consp ifFalse: ["Not a list, but an illegal dot pair."
				^false].
			newterms := nil.
			[terms isNil]
				whileFalse: 
					[car := terms car.
					terms := self fetchValue: terms cdr env: listEnv.
					terms isPrologVariable ifTrue: ["The length of the list has not been fixed yet."
						^false].
					t := PrologTerms car: car cdr: nil.
					newterms isNil
						ifTrue: [newterms := t]
						ifFalse: [newterms := newterms nconc: t]].
			newStruct := PrologStructure functor: functor terms: newterms.
			^self
				unify: termValue
				env: termEnv
				and: newStruct
				env: listEnv]
		ifFalse: 
			["disasemble a term into a list"
			termValue consp
				ifTrue: ["It's a list or a structure."
					list := termValue structureList]
				ifFalse: ["primitive data like symbol, number, nil, or string."
					list := termValue cons: nil].
			^self
				unify: list
				env: termEnv
				and: listVal
				env: listEnv]! !

!PrologInterpreter methodsFor: 'menu messages' stamp: 'nsh 9/8/2008 02:08'!
updatePredList
	self listingListValue list: self predList.
	(self pred isNil
			or: [self pred == 0])
		ifTrue: [self changed: #predList]
		ifFalse: [| symbol | 
			symbol := self predList at: self pred.
			self listingListValue selection: symbol].
	self pred: self pred! !

!PrologInterpreter methodsFor: 'system predicates' stamp: 'nishis 5/3/98 08:08'!
userListing
	| predicateName |
	((self associations: userPredicates) asSortedCollection)
		do: 
			[:assoc | 
			predicateName := assoc key.
			self userListing: predicateName].
	^true! !

!PrologInterpreter methodsFor: 'system predicates' stamp: ''!
userListing: aPrologSymbol 
	| def |
	def := userPredicates at: aPrologSymbol ifAbsent: [nil].
	def == nil ifTrue: [^false].
	[def consp]
		whileTrue: 
			[textCollector show: def car prettyPrintPrologString , '\' withCRs.
			def := def cdr].
	^true! !

!PrologInterpreter methodsFor: 'system predicates' stamp: 'nishis 5/3/98 08:08'!
userPredicates
	| collection list |
	collection := (self associations: userPredicates) asSortedCollection.
	list := nil.
	collection reverseDo: [:each | ((each key respondsTo: #string)
			and: [each key string isEmpty not and: [each key string first = $~]])
			ifTrue: ['not adding: invisible predicate' yourself]
			ifFalse: [list := each key cons: list]].
	^list! !

!PrologInterpreter methodsFor: 'representation' stamp: ''!
variableRepresent: x env: xEnv 
	^PrologVariable install: x string , xEnv car printString! !

!PrologInterpreter methodsFor: 'system predicates' stamp: ''!
verbose: aPrologSymbol 
	aPrologSymbol isPrologTrue
		ifTrue: [verbose := true]
		ifFalse: [verbose := false].
	^true! !

!PrologInterpreter methodsFor: 'system predicates' stamp: ''!
write: anObject 
	(anObject respondsTo: #asString)
		ifTrue: [textCollector show: anObject asString]
		ifFalse: [textCollector show: anObject printPrologString].
	^true! !

Model subclass: #PrologListModel
	instanceVariableNames: 'selectionMenu list selection listIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!

!PrologListModel commentStamp: 'nsh 9/8/2008 06:41' prior: 0!
Prolog
Goodies for Squeak 3.0

This goodies is a modification for Squeak from Mr. AOKI's
Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21

addition for Squeak
!

!PrologListModel class methodsFor: 'examples' stamp: 'nsh 9/7/2008 18:47'!
example
	"PrologListModel example."

	| model listView topView |
	Smalltalk isMorphic ifTrue: [^ self exampleAsMorph].
	model := self new initialize.
	model list: model musicBands.
	listView := PluggableListView on: model
			list: #musicBands
			selected: #selection
			changeSelected: #selection:
			menu: #menu:.
	topView := StandardSystemView new
		label: 'PrologListModel Test';
		minimumSize: 200@200;
		borderWidth: 1;
		addSubView: listView.
	topView controller open.! !

!PrologListModel class methodsFor: 'private' stamp: 'nsh 9/7/2008 19:20'!
exampleAsMorph
	"PrologListModel example."
	| model listView topView |
	model := self new initialize.
	model list: model musicBands.
	listView := PluggableListMorph
				on: model
				list: #musicBands
				selected: #index
				changeSelected: #index:
				menu: #menu:.
	topView := (SystemWindow labelled: 'PrologListModel Test')
				model: model.
	topView minimumExtent: 200 @ 200.
	topView
		addMorph: listView
		frame: (0 @ 0 corner: 1 @ 1).
	[topView visible: false.
	topView openInWorld.
	topView extent: 200 @ 200]
		ensure: [topView visible: true].
	^ topView! !

!PrologListModel class methodsFor: 'instance creation' stamp: 'nsh 9/7/2008 14:33'!
new
	^ super new initialize! !

!PrologListModel methodsFor: 'list' stamp: 'nsh 9/7/2008 14:39'!
changed: what
	super changed: what! !

!PrologListModel methodsFor: 'accessing' stamp: 'nsh 9/7/2008 19:22'!
index
	listIndex isNil ifTrue: [listIndex _ 0].
	^ listIndex! !

!PrologListModel methodsFor: 'accessing' stamp: 'nsh 9/7/2008 19:49'!
index: index 
	self toggleListIndex: index.
	self changed: #listIndex.
! !

!PrologListModel methodsFor: 'initialize-release' stamp: 'nsh 9/7/2008 14:35'!
initialize
	list := nil.
	selection := nil.
	listIndex := 0! !

!PrologListModel methodsFor: 'accessing' stamp: 'nsh 9/7/2008 14:36'!
list
	^ list! !

!PrologListModel methodsFor: 'accessing' stamp: 'nsh 9/7/2008 14:36'!
list: aColection 
	list := aColection.
	listIndex := 0.
	self changed: #list! !

!PrologListModel methodsFor: 'private' stamp: 'nsh 9/7/2008 14:40'!
makeSelectionMenu: aCollection 
	| labels lines selectors |
	aCollection isEmpty
		ifTrue: [^ nil].
	labels := OrderedCollection new.
	lines := OrderedCollection new.
	selectors := OrderedCollection new.
	aCollection
		do: [:association | association isNil
				ifTrue: [lines add: labels size]
				ifFalse: [labels add: association key.
					selectors add: association value]].
	^ SelectionMenu
		labelList: labels asArray
		lines: lines asArray
		selections: selectors asArray! !

!PrologListModel methodsFor: 'pluggable messages' stamp: 'nsh 9/7/2008 19:52'!
menu
	selectionMenu isNil
		ifTrue: [selectionMenu := self makeSelectionMenu: self menuItems].
	^ selectionMenu! !

!PrologListModel methodsFor: 'pluggable messages' stamp: 'nsh 9/7/2008 18:29'!
menu: aMenu 
	^ Smalltalk isMorphic
		ifTrue: [self menuMorph: aMenu]
		ifFalse: [self menu]! !

!PrologListModel methodsFor: 'private' stamp: 'nsh 9/7/2008 19:51'!
menuItems
	| collection |
	collection := OrderedCollection new.
	collection add: 'update' -> #update.
	collection add: 'update:' -> #update:.
	collection add: 'update:with:' -> #update:with:.
	collection add: 'update:with:with:' -> #update:with:with:.
	^ collection! !

!PrologListModel methodsFor: 'pluggable messages' stamp: 'nsh 9/7/2008 19:53'!
menuMorph: aMenu 
	self menuItems
		do: [:each | | selector | aMenu
				add: each key
				target: self
				selector: (selector := each value)
				argumentList: (selector numArgs < 2
						ifTrue: [Array with: self]
						ifFalse: [selector numArgs == 2
								ifTrue: [Array with: self with: #secondParameter]
								ifFalse: [Array
										with: self
										with: #secondParameter
										with: #thirdParameter]])].
	aMenu addLine.
	^ aMenu! !

!PrologListModel methodsFor: 'adaptor' stamp: 'nsh 9/7/2008 14:44'!
musicBands
	^ #('Hatfield and the North' 'National Health' 'Soft Machine' 'Gong' )! !

!PrologListModel methodsFor: 'accessing' stamp: 'nsh 9/7/2008 19:19'!
selection
	^ listIndex = 0 
		ifFalse: [list at: listIndex]
		ifTrue: [nil]! !

!PrologListModel methodsFor: 'accessing' stamp: 'nsh 9/7/2008 21:29'!
selection: aSelection 
	| index |
	(index := list indexOf: aSelection) = 0
		ifFalse: [listIndex == index
				ifTrue: [self changed: #listIndex]
				ifFalse: [self toggleListIndex: index]].
	self changed: #selection! !

!PrologListModel methodsFor: 'pluggable messages' stamp: 'nsh 9/7/2008 19:34'!
smenuMorph: aMenu 
	| collection labelList selectionsArray receiver |
	collection := OrderedCollection new.
	collection add: 'update' -> #update.
	collection add: 'update:' -> #update:.
	collection add: 'update:with:' -> #update:with:.
	collection add: 'update:with:with:' -> #update:with:with:.
	collection.
	labelList := collection
				collect: [:each | each key].
	selectionsArray := collection
				collect: [:each | each value].
	receiver _ thisContext  sender receiver.
collection do: [:each | 
	aMenu
		add: each key 
		target: self
		selector: each value
		argument: receiver
		"argument: (Array with: self with: thisContext sender receiver)"
].
	aMenu addLine.
	^ aMenu! !

!PrologListModel methodsFor: 'list' stamp: 'nsh 9/7/2008 19:29'!
toggleListIndex: aNumber 
	"What to do when the user chooses an item"
	listIndex == aNumber
		ifTrue: [listIndex := 0]
		ifFalse: [listIndex := aNumber].
"	self changed: #listIndex."
	self changed: #index! !

!PrologListModel methodsFor: 'menu messages' stamp: 'nsh 9/7/2008 14:39'!
update
	Transcript cr; show: thisContext printString.
	Transcript cr; tab; show: 'selection is ' , self selection printString! !

!PrologListModel methodsFor: 'menu messages' stamp: 'nsh 9/7/2008 14:39'!
update: selectedString
	Transcript cr; show: thisContext printString.
	Transcript cr; tab; show: 'selection is ' , self selection printString.
	Transcript cr; tab; show: '1st argument is ' , selectedString printString! !

!PrologListModel methodsFor: 'menu messages' stamp: 'nsh 9/7/2008 14:39'!
update: selectedString with: wholeString
	Transcript cr; show: thisContext printString.
	Transcript cr; tab; show: 'selection is ' , self selection printString.
	Transcript cr; tab; show: '1st argument is ' , selectedString printString.
	Transcript cr; tab; show: '2nd argument is ' , wholeString printString! !

!PrologListModel methodsFor: 'menu messages' stamp: 'nsh 9/7/2008 14:39'!
update: selectedString with: wholeString with: aController
	Transcript cr; show: thisContext printString.
	Transcript cr; tab; show: 'selection is ' , self selection printString.
	Transcript cr; tab; show: '1st argument is ' , selectedString printString.
	Transcript cr; tab; show: '2nd argument is ' , wholeString printString.
	Transcript cr; tab; show: '3rd argument is ' , aController printString! !

NoController subclass: #PrologNoController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!

!PrologNoController commentStamp: 'nsh 9/8/2008 06:41' prior: 0!
Prolog
Goodies for Squeak 3.0

This goodies is a modification for Squeak from Mr. AOKI's
Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21

addition for Squeak
!

!PrologNoController methodsFor: 'new selection' stamp: 'nsh 8/31/2008 07:49'!
selectFrom: start to: stop! !

!Object methodsFor: '*Prolog-*prolog' stamp: ''!
car
	self == nil ifTrue: [^nil].
	self error: 'send message car to atom'! !

!Object methodsFor: '*Prolog-*prolog' stamp: ''!
cdr
	self == nil ifTrue: [^nil].
	self error: 'send message cdr to atom'! !

!Object methodsFor: '*Prolog-*prolog' stamp: ''!
cons: anObject 
	^PrologList car: self cdr: anObject! !

!Object methodsFor: '*Prolog-*prolog' stamp: ''!
consp
	^false! !

!Object methodsFor: '*Prolog-*prolog' stamp: ''!
isPrologEntity
	self == nil ifTrue: [^true].
	(self isKindOf: Number)
		ifTrue: [^true].
	^false! !

!Object methodsFor: '*Prolog-*prolog' stamp: ''!
isPrologVariable
	^false! !

!Object methodsFor: '*Prolog-*prolog' stamp: ''!
printPrologOn: aStream 
	self == nil
		ifTrue: 
			[aStream nextPutAll: '[]'.
			^self].
	(self isKindOf: Number)
		ifTrue: 
			[self printOn: aStream.
			^self].
	aStream nextPut: ${.
	self printOn: aStream.
	aStream nextPut: $}! !

!Object methodsFor: '*Prolog-*prolog' stamp: ''!
printPrologOn: aStream level: anInteger 
	self printPrologOn: aStream! !

!Object methodsFor: '*Prolog-*prolog' stamp: ''!
printPrologString
	| aStream |
	aStream := WriteStream on: (String new: 20).
	self printPrologOn: aStream.
	^aStream contents! !

Object subclass: #PrologEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!

!PrologEntity commentStamp: 'nsh 9/8/2008 06:43' prior: 0!
Prolog
Goodies for Squeak 3.0

This goodies is a modification for Squeak from Mr. AOKI's
Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21
!

!PrologEntity class methodsFor: 'copyright' stamp: ''!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!PrologEntity class methodsFor: 'copyright' stamp: ''!
system
	^'Goodies'! !

!PrologEntity class methodsFor: 'copyright' stamp: ''!
version
	^'003'! !

!PrologEntity methodsFor: 'testing' stamp: ''!
isPrologEntity
	^true! !

PrologEntity subclass: #PrologList
	instanceVariableNames: 'carPart cdrPart'
	classVariableNames: 'PrologDotPairPrintHorizontalLevel PrologDotPairPrintVerticalLevel'
	poolDictionaries: ''
	category: 'Prolog'!

!PrologList commentStamp: 'nsh 9/8/2008 06:43' prior: 0!
Prolog
Goodies for Squeak 3.0

This goodies is a modification for Squeak from Mr. AOKI's
Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21
!

PrologList subclass: #PrologBody
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!

!PrologBody commentStamp: 'nsh 9/8/2008 06:44' prior: 0!
Prolog
Goodies for Squeak 3.0

This goodies is a modification for Squeak from Mr. AOKI's
Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21
!

!PrologBody class methodsFor: 'copyright' stamp: ''!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!PrologBody class methodsFor: 'instance creation' stamp: ''!
fromList: aPrologDotPair 
	aPrologDotPair consp ifFalse: [^aPrologDotPair].
	^super new fromList: aPrologDotPair! !

!PrologBody class methodsFor: 'instance creation' stamp: ''!
fromReverseList: aPrologDotPair 
	aPrologDotPair consp ifFalse: [^aPrologDotPair].
	^super new fromReverseList: aPrologDotPair! !

!PrologBody class methodsFor: 'instance creation' stamp: ''!
structure: aPrologStructure next: link 
	^super new structure: aPrologStructure next: link! !

!PrologBody class methodsFor: 'copyright' stamp: ''!
system
	^'Goodies'! !

!PrologBody class methodsFor: 'copyright' stamp: ''!
version
	^'003'! !

!PrologBody methodsFor: 'private' stamp: ''!
fromList: aPrologDotPair 
	^self fromReverseList: aPrologDotPair reverse! !

!PrologBody methodsFor: 'private' stamp: ''!
fromReverseList: aPrologDotPair 
	| list body mark |
	list := aPrologDotPair.
	body := nil.
	[list consp]
		whileTrue: 
			[body == nil
				ifTrue: [body := mark := self class structure: list car next: body]
				ifFalse: [body := self class structure: list car next: body].
			list := list cdr].
	mark cdr: list.
	^body! !

!PrologBody methodsFor: 'printing' stamp: ''!
prettyPrintPrologOn: aStream 
	| list |
	list := self.
	aStream cr; tab.
	[list cdr consp]
		whileTrue: 
			[list ~~ self
				ifTrue: 
					[aStream nextPutAll: ', '.
					aStream cr; tab].
			list car printPrologOn: aStream.
			list := list cdr].
	list ~~ self
		ifTrue: 
			[aStream nextPutAll: ', '.
			aStream cr; tab].
	list car printPrologOn: aStream! !

!PrologBody methodsFor: 'printing' stamp: ''!
printPrologOn: aStream 
	| list |
	list := self.
	[list cdr consp]
		whileTrue: 
			[list ~~ self ifTrue: [aStream nextPutAll: ', '].
			list car printPrologOn: aStream.
			list := list cdr].
	list ~~ self ifTrue: [aStream nextPutAll: ', '].
	list car printPrologOn: aStream! !

!PrologBody methodsFor: 'printing' stamp: ''!
printPrologOn: aStream level: anInteger
	self printPrologOn: aStream! !

!PrologBody methodsFor: 'private' stamp: ''!
structure: aPrologStructure next: link 
	carPart := aPrologStructure.
	cdrPart := link! !

PrologList subclass: #PrologClause
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!

!PrologClause commentStamp: 'nsh 9/8/2008 06:43' prior: 0!
Prolog
Goodies for Squeak 3.0

This goodies is a modification for Squeak from Mr. AOKI's
Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21
!

!PrologClause class methodsFor: 'copyright' stamp: ''!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!PrologClause class methodsFor: 'instance creation' stamp: ''!
head: aPrologStructure body: aPrologBody 
	^super new head: aPrologStructure body: aPrologBody! !

!PrologClause class methodsFor: 'copyright' stamp: ''!
system
	^'Goodies'! !

!PrologClause class methodsFor: 'copyright' stamp: ''!
version
	^'003'! !

!PrologClause methodsFor: 'accessing' stamp: ''!
body
	^cdrPart! !

!PrologClause methodsFor: 'accessing' stamp: ''!
body: aPrologBody 
	cdrPart := aPrologBody! !

!PrologClause methodsFor: 'accessing' stamp: ''!
head
	^carPart! !

!PrologClause methodsFor: 'accessing' stamp: ''!
head: aPrologStructure 
	carPart := aPrologStructure! !

!PrologClause methodsFor: 'private' stamp: ''!
head: aPrologStructure body: aPrologBody 
	self head: aPrologStructure.
	self body: aPrologBody! !

!PrologClause methodsFor: 'printing' stamp: ''!
prettyPrintPrologOn: aStream 
	| head body |
	head := self head.
	body := self body.
	head printPrologOn: aStream.
	body ~~ nil
		ifTrue: 
			[aStream nextPutAll: ' :- '.
			body prettyPrintPrologOn: aStream].
	aStream nextPut: $.! !

!PrologClause methodsFor: 'printing' stamp: ''!
prettyPrintPrologString
	| aStream |
	aStream := WriteStream on: (String new: 20).
	self prettyPrintPrologOn: aStream.
	^aStream contents! !

!PrologClause methodsFor: 'printing' stamp: ''!
printPrologOn: aStream 
	| head body |
	head := self head.
	body := self body.
	aStream nextPut: $(.
	head printPrologOn: aStream.
	body == nil
		ifFalse: 
			[aStream nextPutAll: ', '.
			body printPrologOn: aStream].
	aStream nextPut: $)! !

!PrologClause methodsFor: 'printing' stamp: ''!
printPrologOn: aStream level: anInteger
	self printPrologOn: aStream! !

!PrologClause methodsFor: 'printing' stamp: ''!
questionPrintPrologOn: aStream 
	| head body |
	head := self head.
	body := self body.
	aStream nextPutAll: '?- '.
	head printPrologOn: aStream.
	body ~~ nil
		ifTrue: 
			[aStream nextPutAll: ', '.
			body printPrologOn: aStream].
	aStream nextPut: $.! !

PrologList subclass: #PrologDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!

!PrologDefinition commentStamp: 'nsh 9/8/2008 06:43' prior: 0!
Prolog
Goodies for Squeak 3.0

This goodies is a modification for Squeak from Mr. AOKI's
Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21
!

!PrologDefinition class methodsFor: 'instance creation' stamp: ''!
clause: aPrologClause next: link 
	^super new clause: aPrologClause next: link! !

!PrologDefinition class methodsFor: 'copyright' stamp: ''!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!PrologDefinition class methodsFor: 'instance creation' stamp: ''!
fromList: aPrologDotPair 
	aPrologDotPair consp ifFalse: [^aPrologDotPair].
	^super new fromList: aPrologDotPair! !

!PrologDefinition class methodsFor: 'instance creation' stamp: ''!
fromReverseList: aPrologDotPair 
	aPrologDotPair consp ifFalse: [^aPrologDotPair].
	^super new fromReverseList: aPrologDotPair! !

!PrologDefinition class methodsFor: 'copyright' stamp: ''!
system
	^'Goodies'! !

!PrologDefinition class methodsFor: 'copyright' stamp: ''!
version
	^'003'! !

!PrologDefinition methodsFor: 'private' stamp: ''!
clause: aPrologClause next: link 
	carPart := aPrologClause.
	cdrPart := link! !

!PrologDefinition methodsFor: 'private' stamp: ''!
fromList: aPrologDotPair 
	^self fromReverseList: aPrologDotPair reverse! !

!PrologDefinition methodsFor: 'private' stamp: ''!
fromReverseList: aPrologDotPair 
	| list definition |
	list := aPrologDotPair.
	definition := nil.
	[list consp]
		whileTrue: 
			[definition := self class clause: list car next: definition.
			list := list cdr].
	^definition! !

!PrologList class methodsFor: 'instance creation' stamp: ''!
car: carObject cdr: cdrObject 
	^super new car: carObject cdr: cdrObject! !

!PrologList class methodsFor: 'copyright' stamp: ''!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!PrologList class methodsFor: 'class initialization' stamp: ''!
initialize
	"PrologList initialize"

	PrologDotPairPrintVerticalLevel := 10.
	PrologDotPairPrintHorizontalLevel := 100! !

!PrologList class methodsFor: 'instance creation' stamp: ''!
list: anArray
	| size list |
	size := anArray size.
	list := nil.
	size
		to: 1
		by: -1
		do: [:i | list := self car: (anArray at: i) cdr: list].
	^list! !

!PrologList class methodsFor: 'copyright' stamp: ''!
system
	^'Goodies'! !

!PrologList class methodsFor: 'copyright' stamp: ''!
version
	^'003'! !

!PrologList methodsFor: 'testing' stamp: ''!
= anObject 
	anObject consp ifFalse: [^false].
	self car = anObject car ifTrue: [^self cdr = anObject cdr].
	^false! !

!PrologList methodsFor: 'functions' stamp: ''!
append: aPrologDotPair 
	(cdrPart consp)
		ifFalse: [^carPart cons: aPrologDotPair].
	^carPart cons: (cdrPart append: aPrologDotPair)! !

!PrologList methodsFor: 'functions' stamp: ''!
arity
	^2! !

!PrologList methodsFor: 'converting' stamp: ''!
asPrologList
	| list new tail |
	new := self car cons: nil.
	tail := new.
	list := self cdr.
	[list consp]
		whileTrue: 
			[tail cdr: (list car cons: nil).
			tail := tail cdr.
			list := list cdr].
	tail cdr: list.
	^new! !

!PrologList methodsFor: 'functions' stamp: ''!
assoc: anObject 
	| list assoc |
	list := self.
	[list consp]
		whileTrue: 
			[assoc := list car.
			anObject = assoc car ifTrue: [^assoc].
			list := list cdr].
	^nil! !

!PrologList methodsFor: 'accessing' stamp: ''!
car
	^carPart! !

!PrologList methodsFor: 'accessing' stamp: ''!
car: carObject 
	carPart := carObject! !

!PrologList methodsFor: 'private' stamp: ''!
car: carObject cdr: cdrObject 
	carPart := carObject.
	cdrPart := cdrObject! !

!PrologList methodsFor: 'accessing' stamp: ''!
cdr
	^cdrPart! !

!PrologList methodsFor: 'accessing' stamp: ''!
cdr: cdrObject 
	cdrPart := cdrObject! !

!PrologList methodsFor: 'testing' stamp: ''!
consp
	^true! !

!PrologList methodsFor: 'enumerating' stamp: ''!
do: aBlock
	| list |
	list := self.
	[list consp] whileTrue: [
		aBlock value: list car.
		list := list cdr]! !

!PrologList methodsFor: 'functions' stamp: ''!
functor
	^PrologSymbol fromString: '.'! !

!PrologList methodsFor: 'functions' stamp: ''!
length
	| list count |
	list := self.
	count := 0.
	[list consp]
		whileTrue: 
			[count := count + 1.
			list := list cdr].
	^count! !

!PrologList methodsFor: 'functions' stamp: ''!
member: anObject 
	| list |
	list := self.
	[list consp]
		whileTrue: 
			[anObject = list car ifTrue: [^list].
			list := list cdr].
	^nil! !

!PrologList methodsFor: 'functions' stamp: ''!
nconc: aPrologDotPair 
	| list |
	list := self.
	[list consp]
		whileTrue: [(list cdr consp)
				ifTrue: [list := list cdr]
				ifFalse: 
					[list cdr: aPrologDotPair.
					^self]].
	^aPrologDotPair! !

!PrologList methodsFor: 'accessing' stamp: ''!
nth: anInteger 
	| count list |
	anInteger <= 0 ifTrue: [^self].
	count := 1.
	list := self.
	[list consp]
		whileTrue: 
			[count >= anInteger ifTrue: [^list car].
			count := count + 1.
			list := list cdr].
	^nil! !

!PrologList methodsFor: 'printing' stamp: ''!
prettyPrintPrologOn: aStream 
	| head body list |
	head := self car.
	body := self cdr.
	head printPrologOn: aStream.
	body ~~ nil
		ifTrue: 
			[aStream nextPutAll: ' :- '.
			list := body.
			aStream cr; tab.
			[list cdr consp]
				whileTrue: 
					[list ~~ body
						ifTrue: 
							[aStream nextPutAll: ', '.
							aStream cr; tab].
					list car printPrologOn: aStream.
					list := list cdr].
			list ~~ self
				ifTrue: 
					[aStream nextPutAll: ', '.
					aStream cr; tab].
			list car printPrologOn: aStream].
	aStream nextPut: $.! !

!PrologList methodsFor: 'printing' stamp: ''!
prettyPrintPrologString
	| aStream |
	aStream := WriteStream on: (String new: 20).
	self prettyPrintPrologOn: aStream.
	^aStream contents! !

!PrologList methodsFor: 'printing' stamp: ''!
printOn: aStream 
	aStream nextPutAll: self class printString.
	aStream nextPutAll: '('.
	aStream nextPutAll: self printPrologString.
	aStream nextPutAll: ')'! !

!PrologList methodsFor: 'printing' stamp: ''!
printPrologOn: aStream 
	self printPrologOn: aStream level: 1! !

!PrologList methodsFor: 'printing' stamp: ''!
printPrologOn: aStream cdr: tail level: anInteger 
	| d count |
	d := tail.
	count := 1.
	[d consp]
		whileTrue: 
			[count >= PrologDotPairPrintHorizontalLevel
				ifTrue: 
					[aStream nextPutAll: ' ... ]'.
					^self].
			aStream nextPut: $,.
			d car consp
				ifTrue: [d car printPrologOn: aStream level: anInteger + 1]
				ifFalse: [d car printPrologOn: aStream].
			"d car printPrologOn: aStream level: anInteger + 1."
			count := count + 1.
			d := d cdr].
	d isNil
		ifTrue: [aStream nextPut: $]]
		ifFalse: 
			[aStream nextPut: $|.
			d printPrologOn: aStream.
			aStream nextPut: $]]! !

!PrologList methodsFor: 'printing' stamp: ''!
printPrologOn: aStream level: anInteger 
	anInteger > PrologDotPairPrintVerticalLevel
		ifTrue: 
			[aStream nextPutAll: ' ... '.
			^self].
	aStream nextPutAll: '['.
	carPart consp
		ifTrue: [carPart printPrologOn: aStream level: anInteger + 1]
		ifFalse: [carPart printPrologOn: aStream].
	self
		printPrologOn: aStream
		cdr: cdrPart
		level: anInteger! !

!PrologList methodsFor: 'functions' stamp: ''!
reverse
	| list revlist mark |
	list := self.
	revlist := nil.
	[list consp]
		whileTrue: 
			[revlist == nil
				ifTrue: [revlist := mark := list car cons: revlist]
				ifFalse: [revlist := list car cons: revlist].
			list := list cdr].
	mark cdr: list.
	^revlist! !

!PrologList methodsFor: 'functions' stamp: ''!
structureList
	"disassemble prolog structure of myself into a list."
	^self functor cons: ((self car) cons: ((self cdr) cons: nil))! !

PrologList subclass: #PrologStructure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!

!PrologStructure commentStamp: 'nsh 9/8/2008 06:43' prior: 0!
Prolog
Goodies for Squeak 3.0

This goodies is a modification for Squeak from Mr. AOKI's
Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21
!

!PrologStructure class methodsFor: 'copyright' stamp: ''!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!PrologStructure class methodsFor: 'instance creation' stamp: ''!
functor: aPrologSymbol terms: aPrologTerms 
	^super new functor: aPrologSymbol terms: aPrologTerms! !

!PrologStructure class methodsFor: 'copyright' stamp: ''!
system
	^'Goodies'! !

!PrologStructure class methodsFor: 'copyright' stamp: ''!
version
	^'003'! !

!PrologStructure methodsFor: 'accessing' stamp: ''!
arity
	^self terms length! !

!PrologStructure methodsFor: 'accessing' stamp: ''!
functor
	^carPart! !

!PrologStructure methodsFor: 'accessing' stamp: ''!
functor: aPrologSymbol 
	carPart := aPrologSymbol! !

!PrologStructure methodsFor: 'private' stamp: ''!
functor: aPrologSymbol terms: aPrologTerms 
	self functor: aPrologSymbol.
	self terms: aPrologTerms! !

!PrologStructure methodsFor: 'accessing' stamp: ''!
nthTerm: anInteger 
	^cdrPart nth: anInteger! !

!PrologStructure methodsFor: 'printing' stamp: ''!
printPrologOn: aStream 
	| functor terms |
	functor := self functor.
	terms := self terms.
	functor printPrologOn: aStream.
	terms == nil
		ifFalse:
			[(terms consp)
				ifTrue: [terms printPrologOn: aStream]
				ifFalse:
					[aStream nextPutAll: '(|'.
					terms printPrologOn: aStream.
					aStream nextPut: $)]]! !

!PrologStructure methodsFor: 'printing' stamp: ''!
printPrologOn: aStream level: anInteger
	self printPrologOn: aStream! !

!PrologStructure methodsFor: 'functions' stamp: ''!
structureList
	"disassemble prolog structure of myself into a list."
	^(self functor) cons: self terms asPrologList! !

!PrologStructure methodsFor: 'accessing' stamp: ''!
terms
	^cdrPart! !

!PrologStructure methodsFor: 'accessing' stamp: ''!
terms: aPrologTerms 
	cdrPart := aPrologTerms! !

PrologList subclass: #PrologTerms
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!

!PrologTerms commentStamp: 'nsh 9/8/2008 06:43' prior: 0!
Prolog
Goodies for Squeak 3.0

This goodies is a modification for Squeak from Mr. AOKI's
Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21
!

!PrologTerms class methodsFor: 'copyright' stamp: ''!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!PrologTerms class methodsFor: 'instance creation' stamp: ''!
fromList: aPrologDotPair 
	^super new fromList: aPrologDotPair! !

!PrologTerms class methodsFor: 'instance creation' stamp: ''!
fromReverseList: aPrologDotPair 
	^super new fromReverseList: aPrologDotPair! !

!PrologTerms class methodsFor: 'copyright' stamp: ''!
system
	^'Goodies'! !

!PrologTerms class methodsFor: 'instance creation' stamp: ''!
term: term next: link 
	^super new term: term next: link! !

!PrologTerms class methodsFor: 'copyright' stamp: ''!
version
	^'003'! !

!PrologTerms methodsFor: 'private' stamp: ''!
fromList: aPrologDotPair 
	^self fromReverseList: aPrologDotPair reverse! !

!PrologTerms methodsFor: 'private' stamp: ''!
fromReverseList: aPrologDotPair 
	| list terms mark |
	list := aPrologDotPair.
	terms := nil.
	[list consp]
		whileTrue: 
			[terms == nil
				ifTrue: [terms := mark := self class term: list car next: terms]
				ifFalse: [terms := self class term: list car next: terms].
			list := list cdr].
	mark cdr: list.
	^terms! !

!PrologTerms methodsFor: 'printing' stamp: ''!
printPrologOn: aStream 
	| list |
	aStream nextPut: $(.
	list := self.
	[list cdr consp]
		whileTrue: 
			[list ~~ self ifTrue: [aStream nextPut: $,].
			list car printPrologOn: aStream.
			list := list cdr].
	list ~~ self ifTrue: [aStream nextPut: $,].
	list car printPrologOn: aStream.
	list cdr isNil
		ifTrue: [aStream nextPut: $)]
		ifFalse:
			[aStream nextPut: $|.
			list cdr printPrologOn: aStream.
			aStream nextPut: $)]! !

!PrologTerms methodsFor: 'printing' stamp: ''!
printPrologOn: aStream level: anInteger
	self printPrologOn: aStream! !

!PrologTerms methodsFor: 'private' stamp: ''!
term: anObject next: link 
	carPart := anObject.
	cdrPart := link! !

PrologEntity subclass: #PrologObject
	instanceVariableNames: 'source object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!

!PrologObject commentStamp: 'nsh 9/8/2008 06:43' prior: 0!
Prolog
Goodies for Squeak 3.0

This goodies is a modification for Squeak from Mr. AOKI's
Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21
!

!PrologObject class methodsFor: 'copyright' stamp: ''!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!PrologObject class methodsFor: 'instance creation' stamp: 'nishis 5/8/98 22:46'!
readFrom: aStream 
	| buffer char |
	buffer := WriteStream on: (String new: 20).
	
	[char := aStream next.
	char = $}]
		whileFalse: 
			[char == nil ifTrue: [Debugger
					openContext: thisContext
					label: 'Error'
					contents: 'Syntax error near ${ unmatched $}\-- end of file --' withCRs].
			buffer nextPut: char].
	^buffer contents! !

!PrologObject class methodsFor: 'instance creation' stamp: ''!
source: aString object: anObject 
	^super new source: aString object: anObject! !

!PrologObject class methodsFor: 'copyright' stamp: ''!
system
	^'Goodies'! !

!PrologObject class methodsFor: 'copyright' stamp: ''!
version
	^'003'! !

!PrologObject methodsFor: 'testing' stamp: ''!
= anObject 
	anObject class = self class ifFalse: [^false].
	^self object = anObject object! !

!PrologObject methodsFor: 'accessing' stamp: ''!
object
	^object! !

!PrologObject methodsFor: 'accessing' stamp: ''!
object: anObject
	object := anObject! !

!PrologObject methodsFor: 'printing' stamp: ''!
printOn: aStream 
	aStream nextPutAll: self class printString.
	aStream nextPutAll: '('.
	aStream nextPutAll: self object printString.
	aStream nextPutAll: ')'! !

!PrologObject methodsFor: 'printing' stamp: ''!
printPrologOn: aStream 
	aStream nextPut: ${.
	aStream nextPutAll: self source.
	aStream nextPut: $}! !

!PrologObject methodsFor: 'printing' stamp: ''!
printPrologOn: aStream level: anInteger
	self printPrologOn: aStream! !

!PrologObject methodsFor: 'accessing' stamp: ''!
source
	^source! !

!PrologObject methodsFor: 'accessing' stamp: ''!
source: aString
	source := aString! !

!PrologObject methodsFor: 'private' stamp: ''!
source: aString object: anObject 
	self source: aString.
	self object: anObject! !

PrologEntity subclass: #PrologString
	instanceVariableNames: 'string'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!

!PrologString commentStamp: 'nsh 9/8/2008 06:43' prior: 0!
Prolog
Goodies for Squeak 3.0

This goodies is a modification for Squeak from Mr. AOKI's
Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21
!

!PrologString class methodsFor: 'copyright' stamp: ''!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!PrologString class methodsFor: 'instance creation' stamp: ''!
fromString: aString 
	^super new string: aString! !

!PrologString class methodsFor: 'instance creation' stamp: 'nishis 5/8/98 22:47'!
readFrom: aStream 
	| buffer char string |
	buffer := WriteStream on: (String new: 20).
	char := aStream next.
	char = $" ifTrue: [
		[char := aStream peek.
		char ~~ nil]
			whileTrue: 
				[char = $"
					ifTrue: 
						[aStream next.
						char := aStream peek.
						char = $" ifFalse: [^self fromString: buffer contents]].
				buffer nextPut: aStream next]].
	string := aStream upToEnd.
	string size > 100 ifTrue: [string := string copyFrom: 1 to: 100].
	Debugger
		openContext: thisContext
		label: 'Error'
		contents: 'Syntax error near $" unmatched $"\' withCRs , (string = ''
					ifTrue: ['-- end of file --']
					ifFalse: ['--> ' , string])! !

!PrologString class methodsFor: 'copyright' stamp: ''!
system
	^'Goodies'! !

!PrologString class methodsFor: 'copyright' stamp: ''!
version
	^'003'! !

!PrologString methodsFor: 'comparing' stamp: ''!
< aPrologString 
	^self string < aPrologString string! !

!PrologString methodsFor: 'comparing' stamp: ''!
<= aPrologString 
	^self string <= aPrologString string! !

!PrologString methodsFor: 'testing' stamp: ''!
= anObject 
	anObject class = self class ifFalse: [^false].
	^self string = anObject string! !

!PrologString methodsFor: 'comparing' stamp: ''!
> aPrologString 
	^self string > aPrologString string! !

!PrologString methodsFor: 'comparing' stamp: ''!
>= aPrologString 
	^self string >= aPrologString string! !

!PrologString methodsFor: 'converting' stamp: ''!
asString
	^self string! !

!PrologString methodsFor: 'accessing' stamp: ''!
at: index
	^string at: index! !

!PrologString methodsFor: 'accessing' stamp: ''!
at: index put: char
	^string at: index put: char! !

!PrologString methodsFor: 'enumerating' stamp: ''!
do: aBlock
	^self asString do: aBlock! !

!PrologString methodsFor: 'comparing' stamp: ''!
hash
	^self asString hash! !

!PrologString methodsFor: 'printing' stamp: ''!
printOn: aStream 
	aStream nextPutAll: self class printString.
	aStream nextPutAll: '('.
	aStream nextPutAll: self asString.
	aStream nextPutAll: ')'! !

!PrologString methodsFor: 'printing' stamp: ''!
printPrologOn: aStream 
	| i length x |
	aStream nextPut: $".
	i := 0.
	length := string size.
	[(i := i + 1) <= length]
		whileTrue: 
			[aStream nextPut: (x := string at: i).
			x == $" ifTrue: [aStream nextPut: x]].
	aStream nextPut: $"! !

!PrologString methodsFor: 'printing' stamp: ''!
printPrologOn: aStream level: anInteger 
	self printPrologOn: aStream! !

!PrologString methodsFor: 'accessing' stamp: ''!
size
	^string size! !

!PrologString methodsFor: 'accessing' stamp: ''!
string
	^string! !

!PrologString methodsFor: 'accessing' stamp: ''!
string: aString
	string := aString! !

PrologString subclass: #PrologSymbol
	instanceVariableNames: ''
	classVariableNames: 'PrologCut PrologFail PrologSelf PrologSend PrologSymbolTable PrologTrue PrologVar'
	poolDictionaries: ''
	category: 'Prolog'!

!PrologSymbol commentStamp: 'nsh 9/8/2008 06:43' prior: 0!
Prolog
Goodies for Squeak 3.0

This goodies is a modification for Squeak from Mr. AOKI's
Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21
!

!PrologSymbol class methodsFor: 'copyright' stamp: ''!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!PrologSymbol class methodsFor: 'constants' stamp: ''!
cut
	^PrologCut! !

!PrologSymbol class methodsFor: 'private' stamp: ''!
expect: aString on: aStream
	"If aStream contains aString at the current position, then return true and set the position of aStream to the next char of the string.
	else return false and rewind the position."

	| pos string |
	pos := aStream position.
	string := String new.
	aString size timesRepeat: [
		aStream atEnd ifFalse: [string := string , (String with: aStream next)]].
	aString = string
		ifTrue: [^true]
		ifFalse: [
			aStream position: pos.
			^false]! !

!PrologSymbol class methodsFor: 'class initialization' stamp: ''!
initialize
	"PrologSymbol initialize"

	PrologSymbolTable := Dictionary new.
	PrologCut := self install: '!!'.
	PrologTrue := self install: 'true'.
	PrologFail := self install: 'fail'.
	PrologSend := self install: 'send'.
	PrologVar := self install: 'var'.
	PrologSelf := self install: 'self'! !

!PrologSymbol class methodsFor: 'instance creation' stamp: ''!
install: aString 
	| symbol key |
	symbol := PrologSymbolTable at: aString ifAbsent: [nil].
	symbol == nil
		ifTrue: 
			[key := self fromString: aString.
			symbol := self fromString: aString.
			PrologSymbolTable at: key put: symbol].
	^symbol! !

!PrologSymbol class methodsFor: 'instance creation' stamp: 'nishis 5/8/98 22:48'!
readFrom: aStream 
	| map buffer char |
	map := PrologCharMap symbolMap.
	buffer := WriteStream on: (String new: 20).
	char := aStream peek.
	char == $'
		ifTrue: 
			[aStream next.
			
			[char := aStream peek.
			char ~~ nil]
				whileTrue: 
					[char = $'
						ifTrue: 
							[aStream next.
							char := aStream peek.
							char = $' ifFalse: [^self install: buffer contents]].
					buffer nextPut: aStream next].
		Debugger
				openContext: thisContext
				label: 'Error'
				contents: 'Syntax error near $'' unmatched $''\-- end of file --' withCRs].
	(self expect: '=..' on: aStream)
		ifTrue: ["Non standard (or ad hoc) parsing patterns."
			^self install: '=..'].
	[char ~~ nil and: [map at: char asInteger]]
		whileTrue: 
			[buffer nextPut: aStream next.
			char := aStream peek].
	^self install: buffer contents! !

!PrologSymbol class methodsFor: 'copyright' stamp: ''!
system
	^'Goodies'! !

!PrologSymbol class methodsFor: 'copyright' stamp: ''!
version
	^'003'! !

!PrologSymbol methodsFor: 'accessing' stamp: ''!
arity
	^0! !

!PrologSymbol methodsFor: 'accessing' stamp: ''!
functor
	^self! !

!PrologSymbol methodsFor: 'testing' stamp: ''!
isBuiltInPredicate
	self isPrologCut ifTrue: [^true].
	self isPrologTrue ifTrue: [^true].
	self isPrologFail ifTrue: [^true].
	self isPrologSend ifTrue: [^true].
	self isPrologVar ifTrue: [^true].
	^false! !

!PrologSymbol methodsFor: 'testing' stamp: ''!
isPrologCut
	^self = PrologCut! !

!PrologSymbol methodsFor: 'testing' stamp: ''!
isPrologFail
	^self = PrologFail! !

!PrologSymbol methodsFor: 'testing' stamp: ''!
isPrologSelf
	^self = PrologSelf! !

!PrologSymbol methodsFor: 'testing' stamp: ''!
isPrologSend
	^self = PrologSend! !

!PrologSymbol methodsFor: 'testing' stamp: ''!
isPrologTrue
	^self = PrologTrue! !

!PrologSymbol methodsFor: 'testing' stamp: ''!
isPrologVar
	^self = PrologVar! !

!PrologSymbol methodsFor: 'printing' stamp: ''!
printPrologOn: aStream 
	| map flag firstChar i length x |
	map := PrologCharMap symbolMap.
	flag := false.
	self do: [:each | (map at: each asInteger)
			ifFalse: [flag := true]].
	string isEmpty
		ifTrue: 
			[aStream nextPutAll: ''''.
			aStream nextPutAll: '''']
		ifFalse: 
			[firstChar := string at: 1.
			((firstChar >= $A and: [firstChar <= $Z])
				or: [flag])
				ifTrue: 
					[aStream nextPutAll: ''''.
					i := 0.
					length := string size.
					[(i := i + 1) <= length]
						whileTrue: 
							[aStream nextPut: (x := string at: i).
							x == $' ifTrue: [aStream nextPut: x]].
					aStream nextPutAll: '''']
				ifFalse: 
					[i := 0.
					length := string size.
					[(i := i + 1) <= length]
						whileTrue: 
							[aStream nextPut: (x := string at: i).
							x == $' ifTrue: [aStream nextPut: x]]]]! !

!PrologSymbol methodsFor: 'printing' stamp: ''!
printPrologOn: aStream level: anInteger 
	self printPrologOn: aStream! !

PrologString subclass: #PrologVariable
	instanceVariableNames: ''
	classVariableNames: 'PrologVariableCounter PrologVariableTable'
	poolDictionaries: ''
	category: 'Prolog'!

!PrologVariable commentStamp: 'nsh 9/8/2008 06:43' prior: 0!
Prolog
Goodies for Squeak 3.0

This goodies is a modification for Squeak from Mr. AOKI's
Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21
!

!PrologVariable class methodsFor: 'copyright' stamp: ''!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!PrologVariable class methodsFor: 'private' stamp: ''!
countUp
	PrologVariableCounter := PrologVariableCounter + 1! !

!PrologVariable class methodsFor: 'class initialization' stamp: ''!
initialize
	"PrologVariable initialize"

	self setZero.
	PrologVariableTable := Dictionary new! !

!PrologVariable class methodsFor: 'instance creation' stamp: ''!
install: aString 
	| variable key |
	variable := PrologVariableTable at: aString ifAbsent: [nil].
	variable == nil
		ifTrue: 
			[key := aString.
			variable := self fromString: aString.
			PrologVariableTable at: key put: variable].
	^variable! !

!PrologVariable class methodsFor: 'instance creation' stamp: ''!
readFrom: aStream 
	| map buffer char |
	map := PrologCharMap variableMap.
	buffer := WriteStream on: (String new: 20).
	char := aStream peek.
	(char ~~ nil and: [char = $~])
		ifTrue: 
			[aStream next.
			self countUp.
			^self install: '~' , PrologVariableCounter printString].
	[char ~~ nil and: [map at: char asInteger]]
		whileTrue: 
			[buffer nextPut: aStream next.
			char := aStream peek].
	^self install: buffer contents! !

!PrologVariable class methodsFor: 'private' stamp: ''!
setZero
	PrologVariableCounter := 0! !

!PrologVariable class methodsFor: 'copyright' stamp: ''!
system
	^'Goodies'! !

!PrologVariable class methodsFor: 'copyright' stamp: ''!
version
	^'003'! !

!PrologVariable methodsFor: 'testing' stamp: ''!
isPrologVariable
	^true! !

!PrologVariable methodsFor: 'printing' stamp: ''!
printPrologOn: aStream 
	(self asString at: 1)
		= $~
		ifTrue: [aStream nextPut: $~]
		ifFalse: [aStream nextPutAll: self asString]! !

!PrologVariable methodsFor: 'printing' stamp: ''!
printPrologOn: aStream level: anInteger
	self printPrologOn: aStream! !

Object subclass: #PrologScanner
	instanceVariableNames: 'source mark token tokenType typeTable endChar'
	classVariableNames: 'EndChar'
	poolDictionaries: ''
	category: 'Prolog'!

!PrologScanner commentStamp: 'nsh 9/8/2008 06:43' prior: 0!
Prolog
Goodies for Squeak 3.0

This goodies is a modification for Squeak from Mr. AOKI's
Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21
!

PrologScanner subclass: #PrologParser
	instanceVariableNames: 'prevMark prevToken prevTokenType failBlock compiler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!

!PrologParser commentStamp: 'nsh 9/8/2008 06:43' prior: 0!
Prolog
Goodies for Squeak 3.0

This goodies is a modification for Squeak from Mr. AOKI's
Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21
!

!PrologParser class methodsFor: 'copyright' stamp: ''!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!PrologParser class methodsFor: 'copyright' stamp: ''!
system
	^'Goodies'! !

!PrologParser class methodsFor: 'copyright' stamp: ''!
version
	^'003'! !

!PrologParser methodsFor: 'private' stamp: ''!
compileAndEvaluate: string 
	compiler isNil ifTrue: [compiler := Compiler new].
	^compiler
		evaluate: string
		in: nil
		to: nil
		notifying: nil
		ifFail: []! !

!PrologParser methodsFor: 'private' stamp: ''!
init: sourceStream ifFail: aBlock 
	super on: sourceStream.
	failBlock := aBlock.
	PrologVariable setZero! !

!PrologParser methodsFor: 'scanning' stamp: ''!
nextToken
	prevMark := mark.
	prevToken := token.
	prevTokenType := tokenType.
	^super nextToken! !

!PrologParser methodsFor: 'parsing' stamp: 'nishis 5/8/98 22:59'!
parse: sourceStream 
	| label string |
	^self parse: sourceStream
		ifFail: 
			[:errorMessage | 
			label := errorMessage , ' near ' , token printString.
			string := source upToEnd.
			string size > 100 ifTrue: [string := string copyFrom: 1 to: 100].
			self error: label with: (string = ''
						ifTrue: ['-- end of file --']
						ifFalse: ['--> ' , string])]! !

!PrologParser methodsFor: 'parsing' stamp: ''!
parse: sourceStream ifFail: aBlock
	| result |
	self init: sourceStream ifFail: aBlock.
	Cursor read showWhile: [result := self scan].
	^result! !

!PrologParser methodsFor: 'scan' stamp: ''!
scan
	source atEnd ifTrue: [^#eof].
	self nextToken.
	tokenType == #eof ifTrue: [^#eof].
	tokenType == #neck ifTrue: [^true cons: self scanClause]. "resolve clause"
	self unNextToken.
	^false cons: self scanClause "assert clause"! !

!PrologParser methodsFor: 'scan' stamp: ''!
scanBody
	| list |
	list := nil.
	[tokenType ~~ #eof]
		whileTrue: 
			[list := self scanStructure cons: list.
			self nextToken.
			tokenType == #rightParenthesis ifTrue: [^PrologBody fromReverseList: list].
			tokenType == #period ifTrue: [^PrologBody fromReverseList: list].
			tokenType ~~ #comma ifTrue: [failBlock value: 'Syntax error']].
	failBlock value: 'Unexpected eof'! !

!PrologParser methodsFor: 'scan' stamp: ''!
scanClause
	| head |
	head := self scanStructure.
	self nextToken.
	tokenType == #neck ifTrue: [^PrologClause head: head body: self scanBody].
	tokenType == #comma ifTrue: [^PrologClause head: head body: self scanBody].
	tokenType == #period ifTrue: [^PrologClause head: head body: nil].
	tokenType == #rightParenthesis ifTrue: [^PrologClause head: head body: nil].
	self unNextToken.
	failBlock value: 'Syntax error'! !

!PrologParser methodsFor: 'scan' stamp: ''!
scanExpression
	| symbol |
	self nextToken.
	(tokenType == #eof or: [tokenType == #period])
		ifTrue: [^nil].
	tokenType == #number ifTrue: [^token].
	tokenType == #string ifTrue: [^token].
	tokenType == #object ifTrue: [^PrologObject source: token object: (self compileAndEvaluate: token)].
	tokenType == #leftBracket ifTrue: [^self scanList].
	tokenType == #leftParenthesis ifTrue: [^self scanClause].
	(tokenType == #symbol or: [tokenType == #variable])
		ifTrue: 
			[symbol := token.
			self nextToken.
			tokenType == #leftParenthesis
				ifTrue: 
					[self unNextToken.
					self unNextToken.
					^self scanStructure]
				ifFalse: 
					[self unNextToken.
					^symbol]].
	self unNextToken.
	failBlock value: 'Syntax error'! !

!PrologParser methodsFor: 'scan' stamp: ''!
scanList
	| expression |
	self nextToken.
	tokenType == #comma ifTrue: [self nextToken].
	tokenType == #neck ifTrue: [self nextToken].
	tokenType == #rightBracket ifTrue: [^nil].
	tokenType == #leftBracket ifTrue: [^self scanList cons: self scanList].
	tokenType == #verticalBar
		ifTrue: 
			[expression := self scanExpression.
			self nextToken.
			tokenType == #rightBracket
				ifTrue: [^expression]
				ifFalse: [failBlock value: 'Syntax error']].
	self unNextToken.
	expression := self scanExpression.
	^expression cons: self scanList! !

!PrologParser methodsFor: 'scan' stamp: ''!
scanStructure
	| functor terms |
	functor := self nextToken.
	(tokenType == #symbol or: [tokenType == #variable])
		ifTrue: 
			[terms := self scanTerms.
			^PrologStructure functor: functor terms: terms].
	failBlock value: 'Syntax error'! !

!PrologParser methodsFor: 'scan' stamp: ''!
scanTerms
	| list |
	self nextToken.
	tokenType == #leftParenthesis
		ifTrue: 
			[self nextToken.
			(tokenType == #verticalBar or: [tokenType == #rightParenthesis])
				ifTrue:
					[tokenType == #rightParenthesis
						ifTrue: [^nil].
					list := self scanExpression.
					self nextToken.
					tokenType == #rightParenthesis
						ifTrue: [^list]
						ifFalse: [failBlock value: 'Syntax error']]
				ifFalse: [self unNextToken].
			list := nil.
			[tokenType ~~ #eof]
				whileTrue: 
					[list := self scanExpression cons: list.
					self nextToken.
					token == #rightParenthesis ifTrue: [^PrologTerms fromReverseList: list].
					tokenType == #verticalBar
						ifTrue:
							[list := list reverse.
							list := list nconc: self scanExpression.
							self nextToken.
							tokenType == #rightParenthesis
								ifTrue: [^PrologTerms fromList: list]
								ifFalse: [failBlock value: 'Syntax error']].
					tokenType ~~ #comma ifTrue: [failBlock value: 'Syntax error']].
			failBlock value: 'Unexpected eof']
		ifFalse: 
			[self unNextToken.
			^nil]! !

!PrologParser methodsFor: 'scanning' stamp: ''!
unNextToken
	super unNextToken.
	mark := prevMark.
	token := prevToken.
	tokenType := prevTokenType! !

!PrologScanner class methodsFor: 'copyright' stamp: ''!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!PrologScanner class methodsFor: 'class initialization' stamp: ''!
initialize
	"PrologScanner initialize"

	EndChar := $^! !

!PrologScanner class methodsFor: 'instance creation' stamp: ''!
new
	^super new initScanner! !

!PrologScanner class methodsFor: 'copyright' stamp: ''!
system
	^'Goodies'! !

!PrologScanner class methodsFor: 'copyright' stamp: ''!
version
	^'003'! !

!PrologScanner methodsFor: 'error handling' stamp: 'nishis 6/28/1998 05:59'!
error: labelString with: contentsString
	"(PrologScanner new) error: 'error!!' with: 'show must go on'."

	| handler |
	(handler _ Processor activeProcess errorHandler) notNil
		ifTrue:
			[handler value: labelString value: self]
		ifFalse: 
			[Debugger
				openContext: thisContext
				label: labelString
				contents: contentsString]! !

!PrologScanner methodsFor: 'initialize-release' stamp: ''!
initScanner
	typeTable := PrologScannerTable scannerTable.
	endChar := EndChar! !

!PrologScanner methodsFor: 'scanning' stamp: ''!
multiChar: type 
	self perform: type! !

!PrologScanner methodsFor: 'private' stamp: 'nishis 4/21/98 02:27'!
nextChar
	| char |
	char := source next.
	char = Character linefeed ifTrue: [char := Character cr].
	char = Character cr
		ifTrue: 
			[source peek =  Character linefeed ifTrue: [source next].
			char := Character cr].
	char == nil ifTrue: [char := endChar].
	^char! !

!PrologScanner methodsFor: 'scanning' stamp: ''!
nextToken
	| char |
	mark := source position.
	char := self peekChar.
	tokenType := typeTable at: char asInteger.
	[tokenType == #xDelimiter]
		whileTrue: 
			[self nextChar.
			char := self peekChar.
			tokenType := typeTable at: char asInteger].
	(tokenType at: 1) = $x
		ifTrue:[self multiChar: tokenType]
		ifFalse:[self singleChar: tokenType].
	^token! !

!PrologScanner methodsFor: 'initialize-release' stamp: ''!
on: inputStream 
	source := inputStream.
	mark := source position! !

!PrologScanner methodsFor: 'private' stamp: 'nishis 4/21/98 02:27'!
peekChar
	| char |
	char := source peek.
	char = Character linefeed ifTrue: [char := Character cr].
	char = Character cr ifTrue: [char := Character cr].
	char == nil ifTrue: [char := endChar].
	^char! !

!PrologScanner methodsFor: 'scanning' stamp: ''!
singleChar: type 
	self nextChar.
	token := type.
	tokenType == #leftBrace ifFalse: [^self].
	tokenType := #object.
	token := PrologObject readFrom: source! !

!PrologScanner methodsFor: 'private' stamp: ''!
unNextChar
	source skip: -1! !

!PrologScanner methodsFor: 'scanning' stamp: ''!
unNextToken
	source position: mark! !

!PrologScanner methodsFor: 'scanning' stamp: ''!
xBinary
	Debugger
		openContext: thisContext
		label: 'Error'
		contents: 'Syntax error ' , source peek printString , '\' withCRs , source upToEnd! !

!PrologScanner methodsFor: 'scanning' stamp: ''!
xColon
	| char |
	source next.
	char := source peek.
	char = $-
		ifTrue: 
			[tokenType := #neck.
			self singleChar: tokenType]
		ifFalse: 
			[self unNextToken.
			tokenType := #symbol.
			token := PrologSymbol readFrom: source]! !

!PrologScanner methodsFor: 'scanning' stamp: ''!
xComment
	| char |
	[(char := self nextChar) = Character cr]
		whileFalse: [char == endChar
				ifTrue: 
					[tokenType := #eof.
					^self]].
	self nextToken! !

!PrologScanner methodsFor: 'scanning' stamp: ''!
xDigit
	tokenType := #number.
	token := Number readFrom: source! !

!PrologScanner methodsFor: 'scanning' stamp: ''!
xDollar
	self xBinary! !

!PrologScanner methodsFor: 'scanning' stamp: ''!
xDoubleQuote
	tokenType := #string.
	token := PrologString readFrom: source! !

!PrologScanner methodsFor: 'scanning' stamp: ''!
xSign
	| char sign |
	sign := self nextChar.
	char := self peekChar.
	char isDigit
		ifTrue: 
			[tokenType := #number.
			token := Number readFrom: source.
			sign == $- ifTrue: [token := token negated]]
		ifFalse: 
			[self unNextChar.
			tokenType := #symbol.
			token := PrologSymbol readFrom: source]! !

!PrologScanner methodsFor: 'scanning' stamp: ''!
xSingleQuote
	tokenType := #symbol.
	token := PrologSymbol readFrom: source! !

!PrologScanner methodsFor: 'scanning' stamp: ''!
xSymbol
	tokenType := #symbol.
	token := PrologSymbol readFrom: source! !

!PrologScanner methodsFor: 'scanning' stamp: ''!
xVariable
	tokenType := #variable.
	token := PrologVariable readFrom: source! !

TestCase subclass: #PrologInterpreterTest
	instanceVariableNames: 'lengthOfSystemPredicates'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Test'!

!PrologInterpreterTest methodsFor: 'running' stamp: 'nsh 9/8/2008 10:47'!
setUp
	| prolog |
	prolog := PrologInterpreter new.
	lengthOfSystemPredicates := prolog systemPredicates length.
	prolog := nil! !

!PrologInterpreterTest methodsFor: 'testing' stamp: 'nsh 9/8/2008 10:48'!
testExample01
	| string prolog result predicates |
	string := '

	?- remove.	   % remove all predicates in PrologDataBase.
	likes(john,mary).    % assert fact.
	likes(john,wine).    % assert fact.
	likes(mary,wine).    % assert fact.
	likes(mary,john).    % assert fact.
	?- likes(X,Y).		   % question goal.
	?- likes(john,X), likes(mary,X). % question goal.

	'.
	prolog := PrologInterpreter new.
	result := prolog
				refute: string
				action: [:answer | 
					answer keys asSortedCollection
						do: [:s | ].
					true].
	self assert: result = true.
	predicates := OrderedCollection new.
	prolog userPredicates
		do: [:each | each string = 'likes'
				ifTrue: [predicates add: each]].
	self assert: predicates isEmpty not.
	self assert: prolog systemPredicates length == lengthOfSystemPredicates! !

!PrologInterpreterTest methodsFor: 'testing' stamp: 'nsh 9/8/2008 10:48'!
testExample02
	| string prolog result predicates |
	string := '

	?- remove.	   % remove all predicates in PrologDataBase.
	on(hen,cat).
	on(cat,dog).
	on(dog,donkey).
	above(X,Y) :-
	    on(X,Y).
	above(X,Y) :-
	    on(X,Z), above(Z,Y).
	?- on(X,dog).
	?- above(X,dog).

	'.
	prolog := PrologInterpreter new.
	result := prolog
				refute: string
				action: [:answer | 
					answer keys asSortedCollection
						do: [:s | ].
					true].
	self assert: result = true.
	predicates := OrderedCollection new.
	prolog userPredicates
		do: [:each | (each string = 'on' or: [each string = 'above'])
				ifTrue: [predicates add: each]].
	self assert: predicates isEmpty not.
	self assert: prolog systemPredicates length == lengthOfSystemPredicates! !

!PrologInterpreterTest methodsFor: 'testing' stamp: 'nsh 9/8/2008 10:52'!
testExample03
	| string prolog result predicates |
	string := '

	?- remove.	% remove all predicates in PrologDataBase.
	hanoi(N) :-	% This is Hanoi Tower Prolgram.
	    move(N,left,right,center).
	    move(0,X,Y,Z) :- !!.
	move(N,A,B,C) :-
	    -(N,1,M),
	    move(M,A,C,B),
	    inform(A,B),
	    move(M,C,B,A).
	inform(X,Y) :-
	    write([move,disc,from,X,to,Y]),
	    nl.
	?- hanoi(3).	 % question goal.

	'.
	prolog := PrologInterpreter new.
	result := prolog
				refute: string
				action: [:answer | 
					answer keys asSortedCollection
						do: [:s | ].
					true].
	self assert: result = true.
	predicates := OrderedCollection new.
	prolog userPredicates
		do: [:each | (each string = 'move' or: [each string = 'hanoi'])
				ifTrue: [predicates add: each]].
	self assert: predicates isEmpty not.
	self assert: prolog systemPredicates length == lengthOfSystemPredicates! !

!PrologInterpreterTest methodsFor: 'testing' stamp: 'nsh 9/8/2008 10:47'!
testExample04
	| string prolog result |
	string := '?- append(X,Y,[a,b,c,d]).'.
	prolog := PrologInterpreter new.
	result := prolog
				refute: string
				action: [:answer | 
					answer keys asSortedCollection
						do: [:s | ].
					true].
	self assert: result = true.
	self assert: prolog userPredicates isNil.
	self assert: prolog systemPredicates length == lengthOfSystemPredicates! !

!PrologInterpreterTest methodsFor: 'testing' stamp: 'nsh 9/8/2008 10:52'!
testExample05
	| string prolog result predicates |
	string := '

	image({Form extent: 100 @ 100}).
	graphicsContext({Display}).
	point({100@100}).
	?- image(X), graphicsContext(Y), point(Z), send(X,displayOn:at:,[Y,Z]).

	'.
	prolog := PrologInterpreter new.
	result := prolog
				refute: string
				action: [:answer | 
					answer keys asSortedCollection
						do: [:s | s].
					true].
	Smalltalk isMorphic
		ifTrue: [World restoreMorphicDisplay]
		ifFalse: [ScheduledControllers screenController restoreDisplay].
	self assert: result = true.
	predicates := OrderedCollection new.
	prolog userPredicates
		do: [:each | ((each string = 'graphicsContext'
						or: [each string = 'image'])
					or: [each string = 'point'])
				ifTrue: [predicates add: each]].
	self assert: predicates isEmpty not.
	self assert: prolog systemPredicates length == lengthOfSystemPredicates! !

!PrologInterpreterTest methodsFor: 'testing' stamp: 'nsh 9/8/2008 10:54'!
testExample06
	| string prolog result |
	string := '

	?- send(123,+,[456],X).   % X := 123 + 456.

	'.
	prolog := PrologInterpreter new.
	result := prolog
				refute: string
				action: [:answer | 
					answer keys asSortedCollection
						do: [:s | s].
					true].
	self assert: result = true.
	self assert: prolog userPredicates isNil.
	self assert: prolog systemPredicates length == lengthOfSystemPredicates! !

!PrologInterpreterTest methodsFor: 'testing' stamp: 'nsh 9/8/2008 10:56'!
testExample07
	| string prolog result |
	string := '

	?- is(X,+(3,4)).
	?- is(X,F(3,4)).

	'.
	prolog := PrologInterpreter new.
	result := prolog
				refute: string
				action: [:answer | 
					answer keys asSortedCollection
						do: [:s | s].
					true].
	self assert: result = true.
	self assert: prolog userPredicates isNil.
	self assert: prolog systemPredicates length == lengthOfSystemPredicates! !

!PrologInterpreterTest methodsFor: 'testing' stamp: 'nsh 9/8/2008 11:03'!
testExample08
	| string prolog result |
	string := '

	?- append(X,Y,[1,2,3,4]).	

	'.
	prolog := PrologInterpreter new.
	result := prolog
				refute: string
				action: [:answer | 
					answer keys asSortedCollection
						do: [:s | s].
					true].
	prolog acceptWith: string.
	self assert: result = true.
	self assert: prolog userPredicates isNil.
	self assert: prolog contents = string.
	self assert: prolog systemPredicates length == lengthOfSystemPredicates! !

PluggableFileList subclass: #PrologPluggableFileList
	instanceVariableNames: 'canAdd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!

!PrologPluggableFileList commentStamp: 'nsh 9/8/2008 06:41' prior: 0!
Prolog
Goodies for Squeak 3.0

This goodies is a modification for Squeak from Mr. AOKI's
Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21

addition for Squeak
!

!PrologPluggableFileList class methodsFor: 'standard file operations' stamp: 'nsh 9/8/2008 01:37'!
newFile
	^ self newFileFrom: FileDirectory default! !

!PrologPluggableFileList class methodsFor: 'standard file operations' stamp: 'nsh 9/8/2008 04:30'!
newFileFrom: aDirectory 
	^ self newFileFrom: aDirectory prompt: 'Select a Files:' translated! !

!PrologPluggableFileList class methodsFor: 'standard file operations' stamp: 'nsh 9/8/2008 02:02'!
newFileFrom: aDirectory  prompt: prompt 
	^ (self newFileMenu: aDirectory)
		startUpWithCaption: prompt! !

!PrologPluggableFileList class methodsFor: 'instance creation' stamp: 'nsh 9/8/2008 01:32'!
newFileMenu: aDirectory
	| aPrologPluggableFileList |
	aPrologPluggableFileList := super newFileMenu: aDirectory.
	aPrologPluggableFileList canAdd: true.
	^ aPrologPluggableFileList! !

!PrologPluggableFileList class methodsFor: 'standard file operations' stamp: 'nsh 9/8/2008 01:53'!
newFilePrompt: prompt 
	^ self newFileFrom: FileDirectory default prompt: prompt! !

!PrologPluggableFileList class methodsFor: 'standard file operations' stamp: 'nsh 9/8/2008 01:37'!
oldFile
	^ self oldFileFrom: FileDirectory default! !

!PrologPluggableFileList class methodsFor: 'standard file operations' stamp: 'nsh 9/8/2008 04:32'!
oldFileFrom: aDirectory 
	^ self oldFileFrom: aDirectory prompt: 'Select a File:' translated! !

!PrologPluggableFileList class methodsFor: 'standard file operations' stamp: 'nsh 9/8/2008 01:51'!
oldFileFrom: aDirectory prompt: prompt 
	^ (self oldFileMenu: aDirectory)
		startUpWithCaption: prompt! !

!PrologPluggableFileList class methodsFor: 'instance creation' stamp: 'nsh 9/8/2008 01:33'!
oldFileMenu: aDirectory
	| aPrologPluggableFileList |
	aPrologPluggableFileList := super oldFileMenu: aDirectory.
	aPrologPluggableFileList canAdd: false.
	^ aPrologPluggableFileList! !

!PrologPluggableFileList class methodsFor: 'standard file operations' stamp: 'nsh 9/8/2008 01:54'!
oldFilePrompt: prompt 
	^ self oldFileFrom: FileDirectory default prompt: prompt! !

!PrologPluggableFileList methodsFor: 'accessing' stamp: 'nsh 9/8/2008 01:31'!
canAdd
	^ canAdd = true! !

!PrologPluggableFileList methodsFor: 'accessing' stamp: 'nsh 9/8/2008 01:32'!
canAdd: aBoolean 
	canAdd := aBoolean = true! !

!PrologPluggableFileList methodsFor: 'file list menu' stamp: 'nsh 9/8/2008 01:35'!
itemsForDirectory: dir 
	| services |
	services := OrderedCollection new.
	dir
		ifNotNil: [services
				addAll: (self class itemsForDirectory: dir).
			services last useLineAfter: true].
	self canAdd
		ifTrue: [services add: self serviceAddNewFile.
			services add: self serviceAddNewDirectory].
	^ services! !

Array variableSubclass: #PrologCharMap
	instanceVariableNames: ''
	classVariableNames: 'SymbolMap VariableMap'
	poolDictionaries: ''
	category: 'Prolog'!

!PrologCharMap commentStamp: 'nsh 9/8/2008 06:43' prior: 0!
Prolog
Goodies for Squeak 3.0

This goodies is a modification for Squeak from Mr. AOKI's
Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21
!

!PrologCharMap class methodsFor: 'copyright' stamp: ''!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!PrologCharMap class methodsFor: 'class initialization' stamp: ''!
initialize
	"PrologCharMap initialize"

	self initializeSymbolMap.
	self initializeVariableMap! !

!PrologCharMap class methodsFor: 'class initialization' stamp: ''!
initializeSymbolMap
	| newMap |
	newMap := self new: 256 withAll: false.
	newMap atAll: ($0 asInteger to: $9 asInteger)
		put: true.
	newMap atAll: ($A asInteger to: $Z asInteger)
		put: true.
	newMap atAll: ($a asInteger to: $z asInteger)
		put: true.
	128 to: 256 do: [:i | newMap at: i put: true].
	#($+ $- $!! $: $* $/ $\ $> $< $= $_) do: [:each | newMap at: each asInteger put: true].
	SymbolMap := newMap! !

!PrologCharMap class methodsFor: 'class initialization' stamp: ''!
initializeVariableMap
	| newMap |
	newMap := self new: 256 withAll: false.
	newMap atAll: ($0 asInteger to: $9 asInteger)
		put: true.
	newMap atAll: ($A asInteger to: $Z asInteger)
		put: true.
	newMap atAll: ($a asInteger to: $z asInteger)
		put: true.
	newMap at: $~ asInteger put: true.
	VariableMap := newMap! !

!PrologCharMap class methodsFor: 'table access' stamp: ''!
symbolMap
	^SymbolMap! !

!PrologCharMap class methodsFor: 'copyright' stamp: ''!
system
	^'Goodies'! !

!PrologCharMap class methodsFor: 'table access' stamp: ''!
variableMap
	^VariableMap! !

!PrologCharMap class methodsFor: 'copyright' stamp: ''!
version
	^'003'! !

!PrologCharMap methodsFor: 'accessing' stamp: ''!
at: index 
	(index isInteger and: [index between: 257 and: 65536])
		ifTrue: [(index - 1) asCharacter isLetter
				ifTrue: [^true]
				ifFalse: [^false]].
	index = 0 ifTrue: [^false].
	^super at: index! !

Array variableSubclass: #PrologScannerTable
	instanceVariableNames: ''
	classVariableNames: 'ScanningTable'
	poolDictionaries: ''
	category: 'Prolog'!

!PrologScannerTable commentStamp: 'nsh 9/8/2008 06:43' prior: 0!
Prolog
Goodies for Squeak 3.0

This goodies is a modification for Squeak from Mr. AOKI's
Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21
!

!PrologScannerTable class methodsFor: 'copyright' stamp: ''!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!PrologScannerTable class methodsFor: 'class initialization' stamp: ''!
initialize
	"PrologScannerTable initialize."

	| newTable |
	newTable := self new: 256 withAll: #xBinary.
	newTable atAll: #(9 10 12 13 32 ) put: #xDelimiter.
	newTable atAll: ($0 asInteger to: $9 asInteger) put: #xDigit.
	newTable atAll: ($A asInteger to: $Z asInteger) put: #xVariable.
	newTable at: $~ asInteger put: #xVariable.
	newTable atAll: ($a asInteger to: $z asInteger) put: #xSymbol.
	128 to: 256 do: [:i | newTable at: i put: #xSymbol].
	#($!! $: $* $/ $\ $> $< $= $_) do: [:each | newTable at: each asInteger put: #xSymbol].
	newTable at: $^ asInteger put: #eof.
	newTable at: $" asInteger put: #xDoubleQuote.
	newTable at: $$ asInteger put: #xDollar.
	newTable at: $' asInteger put: #xSingleQuote.
	newTable at: $( asInteger put: #leftParenthesis.
	newTable at: $) asInteger put: #rightParenthesis.
	newTable at: $. asInteger put: #period.
	newTable at: $: asInteger put: #xColon.
	newTable at: $? asInteger put: #xColon.
	newTable at: $; asInteger put: #semicolon.
	newTable at: $[ asInteger put: #leftBracket.
	newTable at: $] asInteger put: #rightBracket.
	newTable at: ${ asInteger put: #leftBrace.
	newTable at: $} asInteger put: #rightBrace.
	newTable at: $, asInteger put: #comma.
	newTable at: $| asInteger put: #verticalBar.
	newTable at: $+ asInteger put: #xSign.
	newTable at: $- asInteger put: #xSign.
	newTable at: $% asInteger put: #xComment.
	ScanningTable := newTable! !

!PrologScannerTable class methodsFor: 'table access' stamp: ''!
scannerTable
	^ScanningTable! !

!PrologScannerTable class methodsFor: 'copyright' stamp: ''!
system
	^'Goodies'! !

!PrologScannerTable class methodsFor: 'copyright' stamp: ''!
version
	^'003'! !

!PrologScannerTable methodsFor: 'accessing' stamp: ''!
at: index 
	(index isInteger and: [index between: 257 and: 65536])
		ifTrue: [(index - 1) asCharacter isLetter
				ifTrue: [^#xSymbol]
				ifFalse: [^#xBinary]].
	index = 0 ifTrue: [^#xDelimiter].
	^super at: index! !
PrologInterpreter initialize!
PrologList initialize!
PrologSymbol initialize!
PrologVariable initialize!
PrologScanner initialize!
PrologCharMap initialize!
PrologScannerTable initialize!
